#include "Karten.h"
#include "Button.h"
#include "Util.h"
#include <sstream>


sf::Text Gewonnen(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
sf::Text KontoStand(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
sf::Text Portemonnaie(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
sf::Text Aktion(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
sf::Clock tAktion;
sf::Clock tZigarretten, Bier;
sf::Text Passt(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
bool Zigarretten;
bool Pleite;

std::string ConvertToEUR(float Betrag) {
	std::ostringstream os;
	os.imbue(std::locale(""));
	if(Betrag < 1.0f && Betrag > -1.0f) {
		os << (int)std::round(Betrag*100) << " ct";
		return(os.str());
	}
	else {
		float Rest = Betrag - static_cast<int>(Betrag);
		if (Rest < 0.01f || Rest > 0.99f) {
			os << static_cast<int>(Betrag) << ",- EUR";
			return os.str();
		}
		else {
			os.precision(2);
			os << std::fixed << Betrag << " EUR";
			return os.str();
		}
	}
}

void newAction(const std::string& akt) {
	Aktion.setString(Aktion.getString() + "\n" + akt);
}

void NeuesSpiel(Kartenblatt* Blatt, int EinsatzNiveau) {
	Einsatz = std::max(0.5f, (static_cast<float>(static_cast<int>(Konto*1/(1+EinsatzNiveau)*100)))/100);
	Konto -= Einsatz;
	newAction("Neues Spiel gestartet. Einsatz: " + ConvertToEUR(Einsatz));
	SetStatus(PLAYER1);
	for(int i = 0; i < 3; i++) {
		Blatt->EineGeben();
	}
}

int main() {
	std::srand(static_cast<unsigned int>(std::time(nullptr)));
	sf::Texture& KarteHinten = RM().get<sf::Texture>("Grafik/KarteHinten.png");
	Kartenblatt Blatt(sf::Vector2f(13, 280-KarteHinten.getSize().y/2*0.7f));
	sf::RenderWindow RW(sf::VideoMode(800, 600), "17 und 4", sf::Style::Close, sf::ContextSettings(0, 0, 4));
	RW.setVerticalSyncEnabled(true);
	sf::Event EV;

	SpielVorbei = true;
	Konto = 10;

	Button Setzen1("Riskanter Einsatz", sf::Vector2f(20, 270), sf::Vector2f(255, 60));
	Button Setzen2("Hoher Einsatz", sf::Vector2f(300, 270), sf::Vector2f(215, 60));
	Button Setzen3("Normaler Einsatz", sf::Vector2f(540, 270), sf::Vector2f(240, 60));
	Button Passen("Passen", sf::Vector2f(10, Blatt.StapelPos.y + KarteHinten.getSize().y*0.7f + 20), sf::Vector2f(Blatt.StapelPos.x + KarteHinten.getSize().x*0.7f + 15, 50));
	Portemonnaie.setString("Portemonnaie:");
	Passt.setString("Compi passt");
	Passt.setColor(sf::Color(0,0,200));
	Passt.setPosition(400 - Passt.getLocalBounds().width/2, 10 + KarteHinten.getSize().y*0.7f);
	Portemonnaie.setCharacterSize(15);
	Aktion.setCharacterSize(20);
	Gewonnen.setCharacterSize(100);
	sf::Sprite sHintergrund(RM().get<sf::Texture>("Grafik/Hintergrund.png"));

	newAction("Sie treffen sich mit Ihrem Freund Compi in einer Kneipe,\n          um dort gegeneinander 17 und 4 zu spielen.");

	while(GetStatus() != ENDE) {
		RW.draw(sHintergrund);
		while(RW.pollEvent(EV)) {
			if(EV.type == sf::Event::Closed) {
				RW.close();
				SetStatus(ENDE);
			}
			if(EV.type == sf::Event::MouseButtonPressed) {
				if(GetStatus() == PLAYER1) {
					if(Passen.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Blatt.IchPasse = true;
					}
					if(!Blatt.IchPasse && EV.mouseButton.x >= Blatt.StapelPos.x - 3 && EV.mouseButton.x <= Blatt.StapelPos.x + KarteHinten.getSize().x * 0.7 + 3 &&
						EV.mouseButton.y >= Blatt.StapelPos.y - 3 && EV.mouseButton.y <= Blatt.StapelPos.y + KarteHinten.getSize().y * 0.7 + 3) {
							Blatt.EineGeben();
					}
				}
				if(GetStatus() == SETZEN) {
					if(Setzen1.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						NeuesSpiel(&Blatt, 1);
					}
					if(Setzen2.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						NeuesSpiel(&Blatt, 2);
					}
					if(Setzen3.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						NeuesSpiel(&Blatt, 3);
					}
				}
			}
		}
		if(Blatt.IchPasse && GetStatus() == PLAYER1) {
			SetStatus(PLAYER2);
		}
		if(Bier.getElapsedTime().asSeconds() > 90 + Random(-10, 10)) {
			newAction("Sie bestellen sich ein neues Bier (2 EUR)");
			Bier.restart();
			Konto -= 2.f;
			if(Random(0, 15) == 0) {
				float f;
				switch(Random(0, 7)) {
					case 0:
						f=0.01f;
						break;
					case 1:
						f=0.02f;
						break;
					case 2:
						f=0.05f;
						break;
					case 3:
						f = 0.1f;
						break;
					case 4:
						f = 0.2f;
						break;
					case 5:
						f = 0.5f;
						break;
					case 6:
						f = 1.f;
						break;
					default:
						f = 2.f;
						break;
				}
				newAction("Sie haben auf dem Weg zum Tresen Geld gefunden. (" + ConvertToEUR(f) + ")");
				Konto += f;
			}
		}
		if(!Zigarretten && tZigarretten.getElapsedTime().asSeconds() > 200 + Random(-30, 30)) {
			newAction("Ihre Schachtel Zigarretten ist aufge(b)raucht.\n    Gefangen in Ihrer Sucht kaufen Sie sich eine Neue fr 5 EUR");
			Zigarretten = true;
			Konto -= 5;
			if(Random(0, 15) == 0) {
				float f;
				switch(Random(0, 7)) {
					case 0:
						f = 0.01f;
						break;
					case 1:
						f = 0.02f;
						break;
					case 2:
						f = 0.05f;
						break;
					case 3:
						f = 0.1f;
						break;
					case 4:
						f = 0.2f;
						break;
					case 5:
						f = 0.5f;
						break;
					case 6:
						f = 1.f;
						break;
					default:
						f = 2.f;
						break;
				}
				newAction("Sie haben auf dem Weg zum Automaten Geld gefunden. (" + ConvertToEUR(f) + ")");
				Konto += f;
			}
		}
		if(Random(0, 20000) == 0) {
			float f = (float)Random(50, static_cast<int>(Konto*100.f)/2);
			f = f / 100.f;
			newAction("Ihnen fehlt Geld. Wei der Himmel, wo es hin ist, aber es fehlen " + ConvertToEUR(f));
			Konto -= f;
		}

		if((GetStatus() == GEWINNER || GetStatus() == BEGINN) && SpielVorbei && Spiel.getElapsedTime().asSeconds() > 3) {
			if(Pleite) {
				sf::sleep(sf::seconds(3));
				RW.close();
				SetStatus(ENDE);
			}
			else {
				Blatt.Mischen();
				SetStatus(SETZEN);
			}
		}
		if(GetStatus() == PLAYER2) {
			Blatt.KI();
		}
		if((GetStatus() == PLAYER1 || GetStatus() == PLAYER2) && !SpielVorbei) {
			Blatt.Gewonnen();
		}
		if(tAktion.getElapsedTime().asSeconds() >= 5) {
			std::string str = Aktion.getString();
			if(str.size() > 0) {
				if(str.find("\n") != -1) {
					if(str.find("\n  ") != -1) {
						str.erase(0, str.find("\n  ")+1);
					}
					if(str.find("\n") != -1) {
						str.erase(0, str.find("\n")+1);
					}
					else {
						str.erase(0, str.size());
					}
				}
				else {
					str.erase(0, str.size());
				}
			}
			Aktion.setString(str);
			tAktion.restart();
		}


		if(GetStatus() == PLAYER1 || GetStatus() == PLAYER2 || GetStatus() == GEWINNER) {
			for(std::deque<Karte*>::reverse_iterator i = Blatt.Stapel.rbegin(); i != Blatt.Stapel.rend(); ++i) {
				RW.draw(**i);
			}
			for(std::set<Karte*>::iterator i = Blatt.Gegner.begin(); i != Blatt.Gegner.end(); ++i) {
				RW.draw(**i);
			}
			for(std::set<Karte*>::iterator i = Blatt.Ich.begin(); i != Blatt.Ich.end(); ++i) {
				RW.draw(**i);
			}
			if(GetStatus() == GEWINNER) {
				if(Konto > 0) {
					if(Patt) {
						Gewonnen.setColor(sf::Color(10,200,10,200));
						Gewonnen.setString("Patt!");
					}
					else {
						if(IGewonnen) {
							Gewonnen.setColor(sf::Color(10,200,10,200));
							Gewonnen.setString("Gewonnen!");
						}
						else  {
							Gewonnen.setColor(sf::Color(200,10,10,200));
							Gewonnen.setString("Verloren!");
						}
					}
				}
				else if(!Pleite) {
					Gewonnen.setColor(sf::Color(200,10,10,200));
					Gewonnen.setString("Sie sind Pleite!");
					Pleite = true;
				}
				Gewonnen.setPosition(400-Gewonnen.getLocalBounds().width/2, 300-Gewonnen.getLocalBounds().height/2-Gewonnen.getLocalBounds().top);
				RW.draw(Gewonnen);
			}
		}
		if(GetStatus() == PLAYER1 || GetStatus() == PLAYER2) {
			RW.draw(Passen);
		}
		if(GetStatus() == SETZEN) {
			RW.draw(Setzen1);
			RW.draw(Setzen2);
			RW.draw(Setzen3);
			Portemonnaie.setPosition(400 - Portemonnaie.getLocalBounds().width/2, 5);
		}
		else {
			if(Konto < 10 || (Konto - static_cast<int>(Konto) == 0 && Konto < 1000)) {
				Portemonnaie.setPosition(777 - Portemonnaie.getLocalBounds().width, 270);
			}
			else if(Konto < 100 || Konto - static_cast<int>(Konto) == 0) {
				Portemonnaie.setPosition(770 - Portemonnaie.getLocalBounds().width, 270);
			}
			else {
				Portemonnaie.setPosition(762 - Portemonnaie.getLocalBounds().width, 270);
			}
		}
		if((GetStatus() == PLAYER1 || GetStatus() == PLAYER2) && Blatt.GegnerPasst) {
			RW.draw(Passt);
		}
		
		RW.draw(Portemonnaie);
		KontoStand.setString(ConvertToEUR(Konto));
		KontoStand.setPosition(Portemonnaie.getPosition().x + (Portemonnaie.getLocalBounds().width - KontoStand.getLocalBounds().width)/2, Portemonnaie.getPosition().y + 20);
		Aktion.setPosition(400-Aktion.getLocalBounds().width/2, 595-Aktion.getLocalBounds().height - Aktion.getLocalBounds().top);
		RW.draw(Aktion);
		RW.draw(KontoStand);
		RW.display();
		RW.clear();
	}
	return(0);
}
