#include "Button.h"


void Button::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Rand, states);
	Target.draw(Text, states);
}

bool Button::IsClicked(sf::Vector2i MousePosition) const {
	MousePosition.x -= static_cast<int>(getPosition().x);
	MousePosition.y -= static_cast<int>(getPosition().y);
	return(MousePosition.x > Rand.getPoint(0).x && MousePosition.x < Rand.getPoint(2).x && MousePosition.y > Rand.getPoint(0).y && MousePosition.y < Rand.getPoint(2).y);
}

void Button::setText(const std::string& sText) {
	Text.setString(sText);
}

Button::Button(const std::string& sText, const sf::Vector2f& Pos, const sf::Vector2f& Size)
	: Text(sText, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	setPosition(Pos);
	Text.setCharacterSize(30);
	Text.setColor(sf::Color::White);
	Text.setPosition((Size.x - Text.getLocalBounds().width) / 2, (Size.y - Text.getCharacterSize() - Text.getLocalBounds().top) / 2);
	Rand = sf::RectangleShape(Size);
	Rand.setFillColor(sf::Color::Transparent);
	Rand.setOutlineColor(sf::Color(255,255,255,80));
	Rand.setOutlineThickness(8);
}
