#include "Karten.h"
#include <random>

Karte::Karte() {
	SetBackImg();
	setScale(0.7f, 0.7f);
}
void Karte::Extract(FARBEN farbe, ZAHLEN zahl) {
	Farbe = farbe;
	Zahl = zahl;
	switch (Zahl) {
		case DAUS:
			Wert = 11;
			break;
		case UNTER:
			Wert = 10;
			break;
		case OBER:
			Wert = 10;
			break;
		case KNIG:
			Wert = 10;
			break;
		default:
			Wert = static_cast<int>(Zahl);
			break;
	}
}
void Karte::SetBackImg()
{
	static sf::Texture& T = RM().get<sf::Texture>("Grafik/KarteHinten.png");
	T.setSmooth(true);
	setTexture(T, true);
}
void Karte::SetFrontImg()
{
	static sf::Texture& T = RM().get<sf::Texture>("Grafik/Kartensatz.png");
	T.setSmooth(true);
	setTexture(T);
	setTextureRect(sf::IntRect((Zahl-1)*KarteX, Farbe*KarteY, KarteX, KarteY));
}


Kartenblatt::Kartenblatt(const sf::Vector2f& Stapelpos) {
	StapelPos = Stapelpos;
	Load();
	Mischen();
}
void Kartenblatt::KI() {
	if(!GegnerPasst) {
		int a = 0;
		for(std::set<Karte*>::iterator i = Gegner.begin(); i != Gegner.end(); ++i) {
			a += (*i)->Wert;
		}
		if(a <= 11) {
			EineGeben();
		}
		if(a > 11 && a < 20) {
			if(Random(0,8) > 20-a) {
				EineGeben();
			}
			else {
				GegnerPasst = true;
				SetStatus(PLAYER1);
			}
		}
		if(a >= 20) {
			GegnerPasst = true;
			SetStatus(PLAYER1);
		}
	}
	else {
		SetStatus(PLAYER1);
	}
}
void Kartenblatt::Gewonnen() {
	int a = 0;
	for(std::set<Karte*>::iterator i = Gegner.begin(); i != Gegner.end(); ++i) {
		a += (*i)->Wert;
	}
	int b = 0;
	for(std::set<Karte*>::iterator i = Ich.begin(); i != Ich.end(); ++i) {
		b += (*i)->Wert;
	}
	if(a > 21) {
		if(!(a == 22 && Gegner.size() == 2)) {
			for(std::set<Karte*>::iterator i = Gegner.begin(); i != Gegner.end(); ++i) {
				(*i)->SetFrontImg();
			}
			if((a == 22 && Gegner.size() == 2)) {
				Einsatz *= 2;
			}
			IGewonnen = true;
			SetStatus(GEWINNER);
		}
	}
	if(b > 21) {
		if(!(b == 22 && Ich.size() == 2)) {
			for(std::set<Karte*>::iterator i = Gegner.begin(); i != Gegner.end(); ++i) {
				(*i)->SetFrontImg();
			}
			if(!(a == 22 && Gegner.size() == 2)) {
				Einsatz = 0;
			}
			IGewonnen = false;
			SetStatus(GEWINNER);
		}
	}
	if(GegnerPasst && IchPasse) {
		for(std::set<Karte*>::iterator i = Gegner.begin(); i != Gegner.end(); ++i) {
			(*i)->SetFrontImg();
		}
		IGewonnen = (b > a);
		if(b == a) {
			Patt = true;
		}
		SetStatus(GEWINNER);
	}
}
void Kartenblatt::Load() {
	for(int i = 0; i < 4; i++) {
		for(int j = 0; j < 13; j++) {
			Karten[i][j].Extract(static_cast<FARBEN>(i), static_cast<ZAHLEN>(j+1));
		}
	}
}

static std::random_device rd;
static std::mt19937 g(rd());
void Kartenblatt::Mischen() {
	Patt = false;
	GegnerPasst = false;
	IchPasse = false;
	for(int i = 0; i < 4; i++) {
		for(int j = 0; j < 13; j++) {
			Karten[i][j].SetBackImg();
		}
	}
	Gegner.clear();
	Ich.clear();
	if(Stapel.size() < 15) {
		Stapel.clear();
		for(int i = 0; i < 4; i++) {
			for(int j = 0; j < 13; j++) {
				Stapel.push_back(&Karten[i][j]);
				Karten[i][j].setRotation(static_cast<float>(Random(-200, 200)) / 100.f);
				Karten[i][j].setPosition(StapelPos - sf::Vector2f(Random(-2, 2), Random(-5, 5)));
			}
		}
		std::shuffle(Stapel.begin(), Stapel.end(), g);
	}
}
void Kartenblatt::EineGeben() {
	(*Stapel.begin())->setPosition(0,0);
	static const sf::Texture& KarteHinten = RM().get<sf::Texture>("Grafik/KarteHinten.png");
	if(GetStatus() == PLAYER1) {
		Stapel.front()->SetFrontImg();
		Ich.insert(*Stapel.begin());
		int count = 0;
		for(std::set<Karte*>::iterator i = Ich.begin(); i != Ich.end(); ++i) {
			switch(Ich.size()) {
				case 1:
					(*i)->setPosition((3.5f+count)*(KarteHinten.getSize().x*0.7f+10)+20, 575-KarteHinten.getSize().y*0.7f);
					break;
				case 2:
					(*i)->setPosition((3+count)*(KarteHinten.getSize().x*0.7f+10)+20, 575-KarteHinten.getSize().y*0.7f);
					break;
				case 3:
					(*i)->setPosition((2.5f+count)*(KarteHinten.getSize().x*0.7f+10)+20, 575-KarteHinten.getSize().y*0.7f);
					break;
				case 4:
					(*i)->setPosition((2+count)*(KarteHinten.getSize().x*0.7f+10)+20, 575-KarteHinten.getSize().y*0.7f);
					break;
				case 5:
					(*i)->setPosition((1.5f+count)*(KarteHinten.getSize().x*0.7f+10)+20, 575-KarteHinten.getSize().y*0.7f);
					break;
				case 6:
					(*i)->setPosition((1+count)*(KarteHinten.getSize().x*0.7f+10)+20, 575-KarteHinten.getSize().y*0.7f);
					break;
				case 7:
					(*i)->setPosition((0.5f+count)*(KarteHinten.getSize().x*0.7f+10)+20, 575-KarteHinten.getSize().y*0.7f);
					break;
				case 8:
					(*i)->setPosition((count)*(KarteHinten.getSize().x*0.7f+10)+20, 575-KarteHinten.getSize().y*0.7f);
					break;
				default:
					break;
			}
			count++;
		}
		SetStatus(PLAYER2);
	}
	else {
		Gegner.insert(*Stapel.begin());
		int count = 0;
		for(std::set<Karte*>::iterator i = Gegner.begin(); i != Gegner.end(); ++i) {
			switch(Gegner.size()) {
				case 1:
					(*i)->setPosition((3.5f+count)*(KarteHinten.getSize().x*0.7f+10)+20, 5);
					break;
				case 2:
					(*i)->setPosition((3+count)*(KarteHinten.getSize().x*0.7f+10)+20, 5);
					break;
				case 3:
					(*i)->setPosition((2.5f+count)*(KarteHinten.getSize().x*0.7f+10)+20, 5);
					break;
				case 4:
					(*i)->setPosition((2+count)*(KarteHinten.getSize().x*0.7f+10)+20, 5);
					break;
				case 5:
					(*i)->setPosition((1.5f+count)*(KarteHinten.getSize().x*0.7f+10)+20, 5);
					break;
				case 6:
					(*i)->setPosition((1+count)*(KarteHinten.getSize().x*0.7f+10)+20, 5);
					break;
				case 7:
					(*i)->setPosition((0.5f+count)*(KarteHinten.getSize().x*0.7f+10)+20, 5);
					break;
				case 8:
					(*i)->setPosition((count)*(KarteHinten.getSize().x*0.7f+10)+20, 5);
					break;
				default:
					break;
			}
			count++;
		}
		SetStatus(PLAYER1);
	}
	Stapel.pop_front();
}