#include "Ball.h"
#include "Ressourcen.h"


void Ball::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Sprite, states);
}

Ball::Ball()
	: Sprite(RM().get<sf::Texture>("Grafik/Ball.png")), Bewegung(250, -135), Stein(RM().get<sf::SoundBuffer>("Sound/Wand.wav")), Wand(RM().get<sf::SoundBuffer>("Sound/Wand.wav")), Schlger(RM().get<sf::SoundBuffer>("Sound/Schlaeger.wav"))
{
	setPosition(75, 384);
	setOrigin(Sprite.getTexture()->getSize().x/2.f, Sprite.getTexture()->getSize().y/2.f); 
}

void Ball::move(float Speed) {
	sf::Vector2f Temp = Bewegung;
	Transformable::move(Speed*Temp.x, Speed*Temp.y);
}

sf::FloatRect Ball::getLocalBounds() const {
	static const sf::Vector2f Size((float)Sprite.getTexture()->getSize().x, (float)Sprite.getTexture()->getSize().y);
	return(sf::FloatRect(getPosition()-getOrigin(), Size));
}

bool Ball::KollisionI(const sf::FloatRect& R) {
	sf::Vector2<bool> v = Collision(Bewegung, getLocalBounds(), R);

	if(v.x) {
		Bewegung.Alpha = 360-Bewegung.Alpha;
	}
	if(v.y) {
		Bewegung.Alpha = 180-Bewegung.Alpha;
	}

	return(v.x||v.y);
}
bool Ball::KollisionW(const sf::FloatRect& R) {
	bool retval = false;

	static const float halfsize = Sprite.getTexture()->getSize().x/2.f;
	if(getPosition().y-halfsize < R.top || getPosition().y+halfsize > R.top+R.height) {
		Bewegung.Alpha = 360-Bewegung.Alpha;
		setPosition(getPosition().x, clamp(R.top, getPosition().y, R.top+R.height));
		retval = true;
	}
	if(getPosition().x-halfsize < R.left || getPosition().x+halfsize > R.left+R.width) {
		Bewegung.Alpha = 180-Bewegung.Alpha;
		setPosition(clamp(R.left, getPosition().x, R.left+R.width), getPosition().y);
		retval = true;
	}


	return(retval);
}
