#include "Button.h"


bool Button::IsClicked(sf::Vector2i MousePosition) const {
	MousePosition.x -= static_cast<int>(getPosition().x);
	MousePosition.y -= static_cast<int>(getPosition().y);
	return(MousePosition.x > Rand.getPoint(0).x && MousePosition.x < Rand.getPoint(2).x && MousePosition.y > Rand.getPoint(0).y && MousePosition.y < Rand.getPoint(2).y);
}

Button::Button(const sf::String& sText, const sf::Vector2f& Position, const sf::Vector2f& Size)
	: Text(sText, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	setPosition(Position);
	float Border = 5;
	Text.setCharacterSize(35);
	Text.setColor(sf::Color(50, 40, 240));
	Text.setPosition((Size.x - Text.getLocalBounds().width) / 2, (Size.y - Text.getCharacterSize() - Text.getLocalBounds().top) / 2);
	Rand = sf::RectangleShape(Size);
	Rand.setFillColor(sf::Color::Transparent);
	Rand.setFillColor(sf::Color(60, 50, 220, 160));
	Rand.setOutlineThickness(Border);
}

void Button::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Rand, states);
	Target.draw(Text, states);
}
