#include "Global.h"
#include "Spiel.h"
#include "Ressourcen.h"
#include "Button.h"
#include "Util.h"


int main() {
	sf::RenderWindow RW(sf::VideoMode(1024, 768), "Breakout", sf::Style::Close, sf::ContextSettings(0, 0, 4));
	RW.setFramerateLimit(60);
	bool Running = true;
	sf::Event EV;

	sf::Sprite Hintergrund(RM().get<sf::Texture>("Grafik/Hintergrund.png"));

	Spiel *spiel = new Spiel;
	
	// "GUI"
	sf::Text Punkte(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Punkte.setStyle(sf::Text::Bold);
	Punkte.setPosition(5, 15);
	Punkte.setCharacterSize(35);
	Punkte.setRotation(-5);
	Punkte.setColor(sf::Color(60, 50, 220, 230));
	sf::Text Level(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Level.setStyle(sf::Text::Bold);
	Level.setCharacterSize(35);
	Level.setRotation(5);
	Level.setColor(sf::Color(60, 50, 220, 230));
	sf::Text Fertig("Spiel durchgespielt!", RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Fertig.setCharacterSize(100);
	Fertig.setPosition(1024/2-Fertig.getLocalBounds().width/2, 768/2-Fertig.getLocalBounds().height/2- Fertig.getLocalBounds().top);
	Fertig.setColor(sf::Color(200, 200, 30, 210));
	sf::Text Countdown("5", RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Countdown.setCharacterSize(200);
	Countdown.setPosition(1024/2-Countdown.getLocalBounds().width/2, 768/2-Countdown.getLocalBounds().height/2-Countdown.getLocalBounds().top);
	Countdown.setColor(sf::Color(220, 50, 60, 210));
	Button Reset("Zurcksetzen", sf::Vector2f(10, 768 - 60), sf::Vector2f(250, 50));
	Button Neustart("Neu starten", sf::Vector2f(400, 768 - 60), sf::Vector2f(244, 50));
	Button Beenden("Beenden", sf::Vector2f(1024-10-200, 768 - 60), sf::Vector2f(200, 50));

	sf::Clock Timer;

	while(Running) {
		while(RW.pollEvent(EV)) {
			switch(EV.type) {
				case sf::Event::Closed:
					Running = false;
					break;
				case sf::Event::KeyReleased:
					if(EV.key.code == sf::Keyboard::Escape)
						Running = false;
					break;
				case sf::Event::MouseButtonReleased:
					if(EV.mouseButton.button == sf::Mouse::Left) {
						if(Reset.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
							spiel->Level = 0;
							delete spiel;
							spiel = new Spiel();
						}
						else if(Neustart.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
							delete spiel;
							spiel = new Spiel();
						}
						else if(Beenden.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
							Running = false;
						}
					}
					break;
			}
		}
		
		spiel->Run(Timer.getElapsedTime().asSeconds(), sf::Mouse::getPosition(RW));
		Timer.restart();

		Punkte.setString("Punkte: " + std::to_string(spiel->Punkte));
		Level.setString("Level: " + std::to_string(spiel->Level));
		Level.setPosition(1024 - Level.getLocalBounds().width - 5, 0);

		RW.clear();
		RW.draw(Hintergrund);
		RW.draw(*spiel);
		switch(GetStatus()) {
			case BEGINN:
				if(Uhr.getElapsedTime().asSeconds() >= 5)
					SetStatus(SPIEL);
				else {
					Countdown.setString(std::to_string(5 - (int)Uhr.getElapsedTime().asSeconds()));
					RW.draw(Countdown);
				}
				break;
			case SPIEL:
				break;
			case ENDE:
				RW.draw(Fertig);
				break;
		}
		RW.draw(Punkte);
		RW.draw(Level);
		RW.draw(Reset);
		RW.draw(Neustart);
		RW.draw(Beenden);
		RW.display();
	}

	delete spiel;
	return(0);
}
