#include "Physik.h"
#include "Util.h"

PhysVec::PhysVec(float x, float alpha) : X(x), Alpha(alpha) {}
PhysVec::PhysVec(const sf::Vector2f& vec) : X(sqrt(vec.x*vec.x+vec.y*vec.y)), Alpha(radtodeg(asin(vec.y/X))) {}

PhysVec::operator sf::Vector2f() const {
	return(sf::Vector2f(X*cos(degtorad(Alpha)), X*sin(degtorad(Alpha))));
}

sf::Vector2<bool> Collision(sf::Vector2f Speed, sf::FloatRect R1, sf::FloatRect R2) {
	sf::FloatRect R3(R1.left-Speed.x, R1.top-Speed.y, R1.width, R1.height);
	if(!R3.intersects(R2) && R1.intersects(R2, R3)) { // Collidate
		return(sf::Vector2<bool>(std::abs(R3.height/Speed.y) <= std::abs(R3.width/Speed.x), std::abs(R3.height/Speed.y) >= std::abs(R3.width/Speed.x)));
	}
	else {
		return(sf::Vector2<bool>(false, false));
	}
}
