#include "Schlaeger.h"
#include "Ressourcen.h"


void Schlger::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Sprite, states);
}

Schlger::Schlger() : Sprite(RM().get<sf::Texture>("Grafik/Schlaeger.png")) {
	setOrigin((float)(Sprite.getTextureRect().width/2), (float)(Sprite.getTextureRect().height/2));
}

void Schlger::setPosition(float x, float y, float Time) {
	move(clamp(Time*-275.f, x - getPosition().x, Time*275.f), clamp(Time*-275.f, y - getPosition().y, Time*275.f));
}

sf::FloatRect Schlger::getLocalBounds() const {
	static const int x = Sprite.getTextureRect().width;
	static const int y = Sprite.getTextureRect().height;
	if(getRotation()==90 || getRotation()==270)
		return(sf::FloatRect(getPosition().x - y/2.f, getPosition().y - x/2.f, (float)y, (float)x));
	else
		return(sf::FloatRect(getPosition().x - x/2.f, getPosition().y - y/2.f, (float)x, (float)y));
}
