#include "Stein.h"
#include "Ressourcen.h"


void Stein::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Sprite, states);
}

Stein::Stein(TYP typ) : Typ(typ) {
	switch(Typ) {
		case FEST:
			Sprite.setTexture(RM().get<sf::Texture>("Grafik/Stein_F.png"));
			break;
		case POSITIV:
			Sprite.setTexture(RM().get<sf::Texture>("Grafik/Stein_P.png"));
			break;
		case NEGATIV:
			Sprite.setTexture(RM().get<sf::Texture>("Grafik/Stein_N.png"));
			break;
		default: // Leere Steine drfen nie erzeugt werden
			throw 0;
			break;
	}
}

Stein::TYP Stein::GetTyp() const {
	return(Typ);
}

sf::FloatRect Stein::getLocalBounds() const {
	static const sf::Vector2f Size((float)Sprite.getTexture()->getSize().x, (float)Sprite.getTexture()->getSize().y);
	return(sf::FloatRect(getPosition(), Size));
}
