#include "Button.h"

bool Button::IsClicked(sf::Vector2i MousePosition) const {
	MousePosition.x -= static_cast<int>(getPosition().x);
	MousePosition.y -= static_cast<int>(getPosition().y);
	if(MousePosition.x > Rand.getPoint(0).x && MousePosition.x < Rand.getPoint(2).x && MousePosition.y > Rand.getPoint(0).y && MousePosition.y < Rand.getPoint(2).y) {
		OnClick();
		return(true);
	}
	return(false);
}

Button::Button(const sf::String& sText, const sf::Vector2f& Position, const sf::Vector2f& Size, std::function<void(void)> onClick)
	: Text(sText, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	setPosition(Position);
	OnClick += onClick;
	float Border = 4;
	Text.setCharacterSize(20);
	Text.setColor(sf::Color::White);
	Text.setPosition((Size.x - Text.getLocalBounds().width) / 2, (Size.y - Text.getCharacterSize() - Text.getLocalBounds().top) / 2);
	Rand = sf::RectangleShape(Size);
	Rand.setFillColor(sf::Color::Transparent);
	Rand.setOutlineColor(sf::Color(255, 255, 255, 155));
	Rand.setOutlineThickness(Border);
}

void Button::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Rand, states);
	Target.draw(Text, states);
}
