#include "Checkbox.h"


CheckBox::CheckBox(const sf::String& text, sf::Vector2f Position, std::function<void(bool)> onChecked, Direction Align, bool CheckState)
	: Checked(CheckState), Text(text, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	setPosition(Position);
	OnChecked += onChecked;
	float Size = 18.f;
	Text.setColor(sf::Color::White);
	Text.setCharacterSize(20);
	CheckMark1.setFillColor(sf::Color::White);
	CheckMark1.setPointCount(4);
	CheckMark1.setPoint(0, sf::Vector2f(0, Size / 2 - 2));
	CheckMark1.setPoint(1, sf::Vector2f(0, Size / 2 + 1));
	CheckMark1.setPoint(2, sf::Vector2f(Size / 2 - 1.5f, Size));
	CheckMark1.setPoint(3, sf::Vector2f(Size / 2 + 1.5f, Size-1));
	CheckMark2.setFillColor(sf::Color::White);
	CheckMark2.setPointCount(5);
	CheckMark2.setPoint(0, sf::Vector2f(Size / 2 - 1.5f, Size-1));
	CheckMark2.setPoint(1, sf::Vector2f(Size / 2 + 1.5f, Size));
	CheckMark2.setPoint(2, sf::Vector2f(Size, 2));
	CheckMark2.setPoint(3, sf::Vector2f(Size, 0));
	CheckMark2.setPoint(4, sf::Vector2f(Size-2, 0));
	Rand = sf::RectangleShape(sf::Vector2f(Size, Size));
	Rand.setOutlineColor(sf::Color(255, 255, 255, 155));
	Rand.setFillColor(sf::Color::Transparent);
	Rand.setOutlineThickness(2);
	if(Align == LINKS) {
		Text.setPosition(Size+5.f, (int)((Size - (float)Text.getCharacterSize() - Text.getLocalBounds().top) / 2.f));
	}
	else {
		move(-Size, 0);
		Text.setPosition(-Text.getLocalBounds().width-5.f, (int)((Size - (float)Text.getCharacterSize() - Text.getLocalBounds().top) / 2.f));
	}
	OnChecked(Checked);
}
void CheckBox::Clicked(sf::Vector2i MousePosition) {
	MousePosition.x -= static_cast<int>(getPosition().x);
	MousePosition.y -= static_cast<int>(getPosition().y);
	if(MousePosition.x > Rand.getPoint(0).x && MousePosition.x < Rand.getPoint(2).x && MousePosition.y > Rand.getPoint(0).y && MousePosition.y < Rand.getPoint(2).y) {
		Checked = !Checked;
		OnChecked(Checked);
	}
}
bool CheckBox::IsChecked() const {
	return(Checked);
}
void CheckBox::Check(bool b) {
	Checked = b;
	OnChecked(Checked);
}
void CheckBox::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	if (Checked) {
		Target.draw(CheckMark1, states);
		Target.draw(CheckMark2, states);
	}
	Target.draw(Rand, states);
	Target.draw(Text, states);
}
