#ifndef GLOBAL_H
#define GLOBAL_H

#include "Ressourcen.h"
#include <SFML/Window.hpp>
#include <cstdint>
#include <functional>
#include <list>

enum Direction {NICHTS, RECHTS, LINKS};

extern sf::VideoMode Auflsung;

template<typename T>
class EventHandler {
	std::list<std::function<void(const T&)> > Funcs;
public:
	void operator+=(std::function<void(const T&)> Func) {
		Funcs.insert(Funcs.end(), Func);
	}
	void operator()(const T& Args) const {
		for(typename std::list<std::function<void(const T&)> >::const_iterator i = Funcs.begin(); i != Funcs.end(); ++i) {
			(*i)(Args);
		}
	}
};
template<>
class EventHandler<void> {
	std::list<std::function<void(void)> > Funcs;
public:
	void operator+=(std::function<void(void)> Func);
	void operator()() const;
};

Resourcemanager& RM();

#endif
