#include "Musik.h"

Player::Player()
	: Thr(std::bind(&Player::Run, this)), Running(false)
{}

void Player::Run() {
	current = Playlist.begin();
	Sound.setBuffer(**current);
	while(Playlist.size() > 0 && Running) {
		Sound.setVolume(0);
		Sound.play();
		for(uint8_t i = 0; i < 100; ++i) {
			sf::sleep(sf::milliseconds(50));
			Sound.setVolume(i+1);
		}
		sf::sleep((*current)->getDuration()-sf::seconds(10));
		for(uint8_t i = 0; i < 100; ++i) {
			Sound.setVolume(99 - i);
			sf::sleep(sf::milliseconds(50));
		}
		sf::sleep(sf::seconds(4));
		++current;
		if(current == Playlist.end()) {
			current = Playlist.begin();
		}
		Sound.setBuffer(**current);
	}
}
void Player::Load(const std::string& filename) {
	Playlist.push_back(&RM().get<sf::SoundBuffer>(filename));
}
void Player::Stop() {
	if(Running) {
		Running = false;
		Sound.stop();
		Thr.terminate();
	}
}
void Player::Start() {
	if(!Running) {
		Running = true;
		Thr.launch();
	}
}
