#include "Spieler.h"

bool MultiForm = false;

void Spieler::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.setView(Vorschau);
	for(uint8_t i = 0; i < nchsteSteine.size(); i++) {
		Target.draw(*nchsteSteine[i], states);
	}
	Target.setView(Target.getDefaultView());
	if(Verloren) {
		Target.draw(VerlorenT, states);
	}
}

Spieler::Spieler(Direction id)
	: VerlorenT("Verloren", RM().get<sf::Font>("../Fonts/sansation.ttf")), ID(id), Verloren(0), Vorschau(sf::FloatRect(0.f, 0.f, (float)Auflsung.width, (float)Auflsung.height))
{
	nchsteSteine.fill(nullptr);
	curSteine.fill(nullptr);
	VerlorenT.setCharacterSize(65);
	VerlorenT.setColor(sf::Color(255, 0, 0, 200));
	Nchste();
	if(ID == RECHTS) {
		Vorschau.move(-static_cast<float>(Auflsung.width/2+96-14), -30);
		VerlorenT.setPosition(Auflsung.width/2.f, Auflsung.height/2.f);
	}
	else {
		Vorschau.move(-static_cast<float>(Auflsung.width/2-96-14), -30);
		VerlorenT.setPosition(Auflsung.width/2.f - VerlorenT.getLocalBounds().width, Auflsung.height/2.f);
	}
}
void Spieler::Nchste() {
	nchsteFormation = static_cast<uint8_t>(MultiForm?(std::rand()%7):0);
	for(uint8_t i = 0; i < curSteine.size(); i++) {
		if(curSteine[i] != 0) {
			curSteine[i]->Besitzer = NICHTS;
			curSteine[i]->Richtung = NICHTS;
		}
		if(nchsteSteine[i] != 0) {
			curSteine[i] = nchsteSteine[i];
		}
		nchsteSteine[i] = new Stein(ID);
	}
	switch(nchsteFormation) {
		case 0:
			nchsteSteine[0]->setPosition(-42, 0);
			nchsteSteine[1]->setPosition(-14, 0);
			nchsteSteine[2]->setPosition(14, 0);
			nchsteSteine[3]->setPosition(42, 0);
			break;
		case 1:
			nchsteSteine[0]->setPosition(-28, 24);
			nchsteSteine[1]->setPosition(-14, 0);
			nchsteSteine[2]->setPosition(14, 0);
			nchsteSteine[3]->setPosition(28, 24);
			break;
		case 2:
			nchsteSteine[0]->setPosition(-21, 24);
			nchsteSteine[1]->setPosition(-7, 0);
			nchsteSteine[2]->setPosition(7, 24);
			nchsteSteine[3]->setPosition(21, 0);
			break;
		case 3:
			nchsteSteine[0]->setPosition(-21, 0);
			nchsteSteine[1]->setPosition(-7, 24);
			nchsteSteine[2]->setPosition(7, 0);
			nchsteSteine[3]->setPosition(21, 24);
			break;
		case 4:
			nchsteSteine[0]->setPosition(-21, 72);
			nchsteSteine[1]->setPosition(-7, 48);
			nchsteSteine[2]->setPosition(7, 24);
			nchsteSteine[3]->setPosition(21, 0);
			break;
		case 5:
			nchsteSteine[0]->setPosition(-21, 0);
			nchsteSteine[1]->setPosition(-7, 24);
			nchsteSteine[2]->setPosition(7, 48);
			nchsteSteine[3]->setPosition(21, 72);
			break;
		default:
			nchsteSteine[0]->setPosition(-14, 24);
			nchsteSteine[1]->setPosition(0, 0);
			nchsteSteine[2]->setPosition(14, 24);
			nchsteSteine[3]->setPosition(0, 48);
			break;
	}
}
void Spieler::Links() {
	for (auto i = curSteine.begin(); i != curSteine.end(); ++i) {
		if(*i != 0) {
			if((*i)->Richtung == RECHTS)
				(*i)->Richtung = NICHTS;
			else
				(*i)->Richtung = LINKS;
		}
	}
}
void Spieler::Rechts() {
	for (auto i = curSteine.begin(); i != curSteine.end(); ++i) {
		if(*i != 0) {
			if((*i)->Richtung == LINKS)
				(*i)->Richtung = NICHTS;
			else
				(*i)->Richtung = RECHTS;
		}
	}
}
Spieler::~Spieler() {
	for(uint32_t i = 0; i < nchsteSteine.size(); ++i) {
		delete nchsteSteine[i];
	}
}