#include "Ball.h"


Ball::Ball()
	: sf::Sprite(RM().get<sf::Texture>("Grafik/Ball.png"))
{
	if(Schwer) {
		Geschwindigkeit.x = 2;
		Geschwindigkeit.y = 2;
	}
	else {
		Geschwindigkeit.x = 1;
		Geschwindigkeit.y = 1;
	}
	if (std::rand() % 2)
		Geschwindigkeit.x = -Geschwindigkeit.x;
	if (std::rand() % 2)
		Geschwindigkeit.y = -Geschwindigkeit.y;
	setPosition((std::rand() % 400) + 200.f, (std::rand() % 500)+50.f);
}

float Ball::getGeschwindigkeit() const {
	return std::abs(Geschwindigkeit.x);
}

void Ball::move(const sf::Vector2f& SchlgerL1, const sf::Vector2f& SchlgerL2, const sf::Vector2f& SchlgerR1, const sf::Vector2f& SchlgerR2, int Blle, uint32_t Time) {
	bool b = false;
	sf::FloatRect ballRect = getTransform().transformRect(getLocalBounds());
	if((ballRect.top <= 0 && Geschwindigkeit.y < 0) || (ballRect.top + ballRect.height >= 600 && Geschwindigkeit.y > 0)) {
		Sound.setBuffer(RM().get<sf::SoundBuffer>("Sound/Tock.wav"));
		Sound.play();
		Geschwindigkeit.y = -Geschwindigkeit.y;
		b = true;
	}
	if(Geschwindigkeit.x < 0) {
		if(ballRect.left <= 0) {
			Sound.setBuffer(RM().get<sf::SoundBuffer>("Sound/TockL.wav"));
			Sound.play();
			Geschwindigkeit.x = -Geschwindigkeit.x;
			PunkteL -= 2;
			b = true;
		}
		else if(ballRect.left <= SchlgerL2.x && ballRect.top + ballRect.height >= SchlgerL1.y && ballRect.top <= SchlgerL2.y) {
			Sound.setBuffer(RM().get<sf::SoundBuffer>("Sound/TickL.wav"));
			Sound.play();
			Geschwindigkeit.x = -Geschwindigkeit.x;
			PunkteL += 3;
			b = true;
		}
	}
	else {
		if(ballRect.left + ballRect.width >= 800) {
			Sound.setBuffer(RM().get<sf::SoundBuffer>("Sound/TockR.wav"));
			Sound.play();
			Geschwindigkeit.x = -Geschwindigkeit.x;
			PunkteR -= 2;
			b = true;
		}
		else if(ballRect.left + ballRect.width >= SchlgerR1.x && ballRect.top + ballRect.height >= SchlgerR1.y && ballRect.top <= SchlgerR2.y) {
			Sound.setBuffer(RM().get<sf::SoundBuffer>("Sound/TickR.wav"));
			Sound.play();
			Geschwindigkeit.x = -Geschwindigkeit.x;
			PunkteR += 3;
			b = true;
		}
	}
	if(b) {
		float G;
		if(modus == 1 || modus == 3) {
			if(Blle < 3) {
				G = 0.5f;
			}
			else {
				G = 0.2f;
			}
		}
		else {
			if(Geschwindigkeit.x < 2 && Geschwindigkeit.x > -2) {
				G = 0.3f;
			}
			else if(Geschwindigkeit.x < 3 && Geschwindigkeit.x > -3) {
				G = 0.2f;
			}
			else {
				G = 0.05f;
			}
		}
		if((Geschwindigkeit.x < 4.5 && Geschwindigkeit.x > -4.5 && !Schwer) || (Geschwindigkeit.x < 7 && Geschwindigkeit.x > -7 && Schwer) || modus == 1 || modus == 3) {
			if(Geschwindigkeit.y < 0) {
				Geschwindigkeit.y -= G;
			}
			else {
				Geschwindigkeit.y += G;
			}
			if(Geschwindigkeit.x < 0) {
				Geschwindigkeit.x -= G;
			}
			else {
				Geschwindigkeit.x += G;
			}
		}
	}
	Sprite::move(Geschwindigkeit * 1.5f * MovFac * ((float)Time/1000.f) * 60.f);
	if(modus == 2 || modus == 3) {
		rotate(Geschwindigkeit.x * 3.6f);
	}
}
