#include "Pong.h"

Pong::Pong()
	: RW(sf::VideoMode(800, 600, 32), "SFML-Pong", sf::Style::Close, sf::ContextSettings(0, 0, 4))
	, LP("0", RM().get<sf::Font>("../Fonts/sansation.ttf"))
	, RP("0", RM().get<sf::Font>("../Fonts/sansation.ttf"))
	, Blle("0", RM().get<sf::Font>("../Fonts/sansation.ttf"))
	, SchlgerKlemmtR("Paddle klemmt!", RM().get<sf::Font>("../Fonts/sansation.ttf"))
	, SchlgerKlemmtL("Paddle klemmt!", RM().get<sf::Font>("../Fonts/sansation.ttf"))
	, sHintergrund(RM().get<sf::Texture>("Grafik/Hintergrund.png"))
	, SchlgerR(RM().get<sf::Texture>("Grafik/Schlger.png"))
	, SchlgerL(RM().get<sf::Texture>("Grafik/Schlger.png"))
	, BT{
			Button("Beenden (B)", sf::Vector2f(20,20), sf::Vector2f(365,80)),
			Button("Leichtes Spiel (L)", sf::Vector2f(415,20), sf::Vector2f(365,80)),
			Button("Schweres Spiel (S)", sf::Vector2f(415,120), sf::Vector2f(365,80)),
			Button("Mehrere Blle (M)", sf::Vector2f(415,220), sf::Vector2f(365,80)),
			Button("Eiernder Ball (E)", sf::Vector2f(415,320), sf::Vector2f(365,80)),
			Button("Eiernde Blle (F)", sf::Vector2f(415,420), sf::Vector2f(365,80)),
			Button("Men (H)", sf::Vector2f(275,15), sf::Vector2f(250,60))
		}
{
	SchlgerR.setPosition(780, 260);
	SchlgerL.setPosition(5+15, 260);
	SchlgerL.setScale(-1.0f, 1.0f);
	LP.setPosition(10,5);
	SchlgerKlemmtL.setColor(sf::Color(200,100,100));
	SchlgerKlemmtR.setColor(sf::Color(200,100,100));
	SchlgerKlemmtL.setPosition(5,40);
	SchlgerKlemmtR.setPosition(800-5-SchlgerKlemmtR.getLocalBounds().width,40);
	InitMen();
}
void Pong::InitMen() {
	PunkteL = 0;
	PunkteR = 0;
	Blle.setPosition(10,557);
	ImSpiel = false;
	RW.setFramerateLimit(20);
	RW.setVerticalSyncEnabled(false);
}
void Pong::StarteSpiel(uint8_t mod, bool sch) {
	MovFac = 1;
	SchlgerGeschw = 5;
	modus = mod;
	Schwer = sch;
	B.clear();
	B.emplace_back();
	ImSpiel = true;
	SchlgerRFree = true;
	SchlgerLFree = true;
	RW.setFramerateLimit(0);
	RW.setVerticalSyncEnabled(true);
	Timer.restart();
}

void Pong::Run() {
	sf::Sound Sound;
	sf::Event EV;

	while(RW.isOpen()) {
		if(ImSpiel) {
			// Texte
			if(modus == 1 || modus == 3) {
				Blle.setString("Blle: " + std::to_string(B.size()));
			}
			LP.setString("Punkte: " + std::to_string(PunkteL));
			RP.setString("Punkte: " + std::to_string(PunkteR));
			RP.setPosition(800 - 10 - RP.getLocalBounds().width, 5);
			
			if(!SchlgerRFree && SchlgerRC.getElapsedTime().asMilliseconds() >= 5000) {
				Sound.setBuffer(RM().get<sf::SoundBuffer>("Sound/TingR.wav"));
				Sound.play();
				SchlgerRFree = true;
			}
			if(!SchlgerLFree && SchlgerLC.getElapsedTime().asMilliseconds() >= 5000) {
				Sound.setBuffer(RM().get<sf::SoundBuffer>("Sound/TingL.wav"));
				Sound.play();
				SchlgerLFree = true;
			}
			if(sf::Keyboard::isKeyPressed(sf::Keyboard::Up) && SchlgerR.getPosition().y > -45 && SchlgerRFree) {
				SchlgerR.move(0, -SchlgerGeschw);
			}
			if(sf::Keyboard::isKeyPressed(sf::Keyboard::Down) && SchlgerR.getPosition().y < 555 && SchlgerRFree) {
				SchlgerR.move(0, SchlgerGeschw);
			}
			if(sf::Keyboard::isKeyPressed(sf::Keyboard::Q) && SchlgerL.getPosition().y > -45 && SchlgerLFree) {
				SchlgerL.move(0, -SchlgerGeschw);
			}
			if(sf::Keyboard::isKeyPressed(sf::Keyboard::A) && SchlgerL.getPosition().y < 555 && SchlgerLFree) {
				SchlgerL.move(0, SchlgerGeschw);
			}
			if(modus == 1 || modus == 3) {
				for(std::vector<Ball>::iterator i = B.begin(); i != B.end(); ++i) {
					if(i->getGeschwindigkeit() > 4.5) {
						i->Geschwindigkeit.x /= 5;
						i->Geschwindigkeit.y /= 5;
						i = B.insert(i, Ball());
					}
				}
			}
			else {
				SchlgerGeschw = 3.5f + B[0].getGeschwindigkeit() * 0.3f;
			}
		}

		RW.draw(sHintergrund);
		if(ImSpiel) {
			if(modus == 1 || modus == 3) {
				RW.draw(Blle);
			}
			RW.draw(LP);
			RW.draw(RP);
			RW.draw(SchlgerR);
			RW.draw(SchlgerL);
			if(PunkteL - PunkteR > 40) {
				sf::Text Gewinner("Der linke Spieler hat gewonnen", RM().get<sf::Font>("../Fonts/sansation.ttf"), 50);
				Gewinner.setPosition(50, 290);
				RW.draw(Gewinner);
			}
			else if(PunkteL - PunkteR < -40) {
				sf::Text Gewinner("Der rechte Spieler hat gewonnen", RM().get<sf::Font>("../Fonts/sansation.ttf"), 50);
				Gewinner.setPosition(30, 290);
				RW.draw(Gewinner);
			}
			else {
				for(std::vector<Ball>::iterator i = B.begin(); i != B.end(); ++i) {
					i->move(
						sf::Vector2f(SchlgerL.getPosition().x - SchlgerR.getTextureRect().width, SchlgerL.getPosition().y), sf::Vector2f(SchlgerL.getPosition().x, SchlgerL.getPosition().y + SchlgerR.getTextureRect().height),
						SchlgerR.getPosition(), sf::Vector2f(SchlgerR.getPosition().x + SchlgerR.getTextureRect().width, SchlgerR.getPosition().y + SchlgerR.getTextureRect().height),
						(int)B.size(), Timer.getElapsedTime().asMilliseconds());
					RW.draw(*i);
				}
				Timer.restart();
				if(PU.Da) {
					RW.draw(PU);
				}
				switch(PU.Check(B)) {
					case 0:
						SchlgerLFree = false;
						SchlgerLC.restart();
						break;
					case 1:
						SchlgerRFree = false;
						SchlgerRC.restart();
						break;
					case 2:
						SlowFast.restart();
						MovFac = 0.5;
						break;
					case 3:
						SlowFast.restart();
						MovFac = 1.5;
						break;
				}
				if(SlowFast.getElapsedTime().asMilliseconds() >= 5000) {
					MovFac = 1;
				}
			}
			if(!SchlgerRFree) {
				RW.draw(SchlgerKlemmtR);
			}
			if(!SchlgerLFree) {
				RW.draw(SchlgerKlemmtL);
			}
			RW.draw(BT[6]);
		}
		else {
			for(int i = 0; i < 6; i++) {
				RW.draw(BT[i]);
			}
		}
		RW.display();
		while (RW.pollEvent(EV)) {
			switch(EV.type) {
				case sf::Event::Closed:
					RW.close();
					break;
				case sf::Event::KeyPressed:
					if(ImSpiel) {
						if(EV.key.code == sf::Keyboard::H) {
							InitMen();
						}
					}
					else {
						switch(EV.key.code) {
							case sf::Keyboard::B:
								RW.close();
								break;
							case sf::Keyboard::L:
								StarteSpiel(0, false);
								break;
							case sf::Keyboard::S:
								StarteSpiel(0, true);
								break;
							case sf::Keyboard::M:
								StarteSpiel(1, false);
								break;
							case sf::Keyboard::E:
								StarteSpiel(2, false);
								break;
							case sf::Keyboard::F:
								StarteSpiel(3, false);
								break;
						}
					}
					break;
				case sf::Event::MouseButtonReleased:
					if(EV.mouseButton.button == sf::Mouse::Left) {
						if(ImSpiel) {
							if(BT[6].IsClicked(sf::Mouse::getPosition(RW))) {
								InitMen();
							}
						}
						else {
							if(BT[0].IsClicked(sf::Mouse::getPosition(RW))) {
								RW.close();
							}
							else if(BT[1].IsClicked(sf::Mouse::getPosition(RW))) {
								StarteSpiel(0, false);
							}
							else if(BT[2].IsClicked(sf::Mouse::getPosition(RW))) {
								StarteSpiel(0, true);
							}
							else if(BT[3].IsClicked(sf::Mouse::getPosition(RW))) {
								StarteSpiel(1, false);
							}
							else if(BT[4].IsClicked(sf::Mouse::getPosition(RW))) {
								StarteSpiel(2, false);
							}
							else if(BT[5].IsClicked(sf::Mouse::getPosition(RW))) {
								StarteSpiel(3, false);
							}
						}
					}
					break;
			}
		}
	}
}
