#include "Auto.h"
#include <cmath>
#include "Utils.h"


const float Auto::m = 1500;


Auto::Auto()
	: shapeImg(nullptr)
{
	Qualm1.Angle = 180;
	Qualm2.Angle = 180;
}

void Auto::Init(bool Grn) {
	if(Grn) {
		Sp.setTexture(RM().get<sf::Texture>("Grafik/Auto1.png"));
		shapeImg = &RM().get<sf::Image>("Grafik/Auto1.png");
		Lenkfaktor = 70;
		F = 4000;
	}
	else {
		Sp.setTexture(RM().get<sf::Texture>("Grafik/Auto2.png"));
		shapeImg = &RM().get<sf::Image>("Grafik/Auto2.png");
		Lenkfaktor = 60;
		F = 5000;
	}
	Sp.setOrigin((float)Sp.getTexture()->getSize().x/2, (float)Sp.getTexture()->getSize().y/2);
}

void Auto::restart() {
	v = 0;
	Angle = 0;
	Sp.setRotation(0);
}

void Auto::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	Target.draw(Sp, states);
	Target.draw(Qualm1, states);
	Target.draw(Qualm2, states);
}

sf::Image& Auto::GetImage() const
{
	return *shapeImg;
}

void Auto::Beschleunigen(bool Ja, bool Vorwrts, sf::Int32 t) {
	float a = 0;
	if (Ja) {
		if (Vorwrts)
			a = 40.0f * F / m;
		else
			a = -40.0f * F / m;
		v += a * (t / 1000.f);
	}
	else {
		a = (0.012f * 9.81f * m);

		if (v > 0.001f)
			v = std::max(0.f, v - a * (t / 1000.f));
		else if (v < -0.001f)
			v = std::min(0.f, v + a * (t / 1000.f));
		else
			v = 0.f;
	}
}

void Auto::move(sf::Int32 t) {
	Qualm1.Run(t);
	Qualm2.Run(t);
	Sp.move(CreateVector(Angle, v*(t / 1000.f)));
	Qualm1.Position = Sp.getPosition() + CreateVector(198.28f+Angle, 117);
	Qualm2.Position = Sp.getPosition() + CreateVector(196.48f+Angle, 116);
	Sp.setRotation(-Angle);
	Qualm1.Angle = 180+Angle;
	Qualm2.Angle = 180+Angle;
}

void Auto::Lenken(bool Rechts, sf::Int32 time) {
	if(v < 0) {
		Rechts = !Rechts;
	}
	float lf = Lenkfaktor * (time / 1000.f);
	float x = 150.0f * std::tan(degtorad(lf));
	if(x > std::max(v, -v)*(time / 1000.f)) {
		x = std::max(v, -v)*(time / 1000.f);
		lf = radtodeg(std::atan(x/150.0f));
	}
	if(Rechts) {
		Angle -= lf;
	}
	else {
		Angle += lf;
	}
}
