#include "CheckBox.h"
#include "Utils.h"


CheckBoxGroup::CheckBoxGroup(std::initializer_list<CheckBox*> boxen)
	: Boxen(boxen)
{
	for (size_t i = 0; i < Boxen.size(); i++)
		Boxen[i]->Group = this;
}

void CheckBoxGroup::Check(CheckBox* Activator) {
	for(std::vector<CheckBox*>::iterator i = Boxen.begin(); i != Boxen.end(); ++i) {
		(*i)->Checked = (*i == Activator);
	}
}

CheckBox::CheckBox(sf::Vector2f Position, const sf::String& text, float LineWidth, float Size, bool CheckState, const sf::Color& Col)
	: Group(nullptr), Checked(CheckState), Text(text, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	Position.x += LineWidth;
	Position.y += LineWidth;
	setPosition(Position);
	Size -= LineWidth;
	CheckMark1.setFillColor(Col);
	CheckMark1.setPointCount(4);
	CheckMark1.setPoint(0, sf::Vector2f(0, Size / 2 - 2));
	CheckMark1.setPoint(1, sf::Vector2f(0, Size / 2 + 1));
	CheckMark1.setPoint(2, sf::Vector2f(Size / 2 - 1.5f, Size));
	CheckMark1.setPoint(3, sf::Vector2f(Size / 2 + 1.5f, Size - 1));
	CheckMark2.setFillColor(Col);
	CheckMark2.setPointCount(5);
	CheckMark2.setPoint(0, sf::Vector2f(Size / 2 - 1.5f, Size - 1));
	CheckMark2.setPoint(1, sf::Vector2f(Size / 2 + 1.5f, Size));
	CheckMark2.setPoint(2, sf::Vector2f(Size, 2));
	CheckMark2.setPoint(3, sf::Vector2f(Size, 0));
	CheckMark2.setPoint(4, sf::Vector2f(Size - 2, 0));
	Rand = sf::RectangleShape(sf::Vector2f(Size, Size));
	Rand.setOutlineThickness(LineWidth);
	Rand.setFillColor(sf::Color::Transparent);
	Rand.setOutlineColor(sf::Color(Col.r,Col.g,Col.b,std::max<sf::Uint8>(Col.a - 155, 0)));
	Text.setPosition(Size+5, -6);
	Text.setColor(Col);
	Text.setCharacterSize(20);
}

void CheckBox::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	if(Checked) {
		Target.draw(CheckMark1, states);
		Target.draw(CheckMark2, states);
	}
	Target.draw(Rand, states);
	Target.draw(Text, states);
}

bool CheckBox::IsClicked(sf::Vector2i MousePosition) {
	MousePosition.x -= static_cast<int>(getPosition().x);
	MousePosition.y -= static_cast<int>(getPosition().y);
	bool b = MousePosition.x > Rand.getPoint(0).x && MousePosition.x < Rand.getPoint(2).x && MousePosition.y > Rand.getPoint(0).y && MousePosition.y < Rand.getPoint(2).y;
	if(b) {
		Checked = !Checked;
		Group->Check(this);
	}
	return(b);
}

bool CheckBox::IsChecked() const {
	return(Checked);
}
