#include "Karte.h"
#include <sstream>
#include <fstream>
#include <iomanip>


void Karte::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	Target.draw(Sp, states);
}
sf::Vector2<bool> Karte::Kollision(Auto& A) {
	for(int x = 0; x < A.Sp.getTextureRect().width; ++x) {
		for(int y = 0; y < A.Sp.getTextureRect().height; ++y) {
			if(A.GetImage().getPixel(x, y).a == 0)
				continue;

			sf::Vector2f pos = A.Sp.getTransform().transformPoint((float)x, (float)y);
			sf::Color temp = renderedBackImage.getPixel((unsigned int)pos.x, (unsigned int)pos.y);

			if(temp == sf::Color(2,2,2))
				return(sf::Vector2<bool>(false, true));
			if(temp == sf::Color::Black)
				return(sf::Vector2<bool>(true, false));
		}
	}
	return(sf::Vector2<bool>(false, false));
}
bool Karte::LoadFile(const std::string& Kartenname) {
	sf::Vector2i StartPos;
	sf::Vector2i Size;

	std::ifstream ifs(("../../Daten/Mr. X Racer/Karten/" + Kartenname + ".rsf").c_str());
	if(!ifs.good()) {
		return false;
	}
	std::string str;
	std::getline(ifs, str);
	if(str != "#") {
		return false;
	}
	try {
		std::istringstream iss;
		//Zeile 1
		std::getline(ifs, str);
		iss.str(str.substr(0, str.find("|")));
		iss >> Size.x;
		iss.clear();
		iss.str(str.substr(str.find("|")+1));
		iss >> Size.y;
		iss.clear();
		//Zeile 2
		std::getline(ifs, str);
		iss.str(str.substr(0, str.find("|")));
		iss >> StartPos.x;
		iss.clear();
		iss.str(str.substr(str.find("|")+1));
		iss >> StartPos.y;
		iss.clear();
		//Startposition Setzen
		Grn.restart();
		Lila.restart();
		Grn.Sp.setPosition((float)(StartPos.x * 300 + 149), (float)(StartPos.y * 300 + 188));
		Lila.Sp.setPosition((float)(StartPos.x * 300 + 149), (float)(StartPos.y * 300 + 188));
		//renderedImage vorbereiten
		sf::Image renderedTempImage;
		renderedTempImage.create(Size.x * 300, Size.y * 300, sf::Color(0,200,0));
		renderedBackImage.create(Size.x * 300, Size.y * 300, sf::Color(255,0,0));
		//Schleife
		for(int y = 0; y < Size.y; ++y) {
			for(int x = 0; x < Size.x; ++x) {
				renderedTempImage.copy(RM().get<sf::Image>("Grafik/GrasTile.png"), x*300, y*300);
			}
		}
		int temp;
		for(int y = 0; y < Size.y; ++y) {
			std::getline(ifs, str);
			for(int x = 0; x < Size.x; ++x) {
				iss.str(str.substr(0, 2));
				iss >> temp;
				if(temp < 24) {
					std::ostringstream os;
					os << std::setw(2) << std::setfill('0') << temp;
					renderedBackImage.copy(RM().get<sf::Image>("Grafik/" + os.str() + ".png"), x*300, y*300, sf::IntRect(0,0,0,0), true);
					renderedTempImage.copy(RM().get<sf::Image>("Grafik/" + os.str() + ".png"), x*300, y*300, sf::IntRect(0,0,0,0), true);
					if(temp == 2 || temp == 9 || temp == 12 || temp == 18) {
						renderedBackImage.copy(RM().get<sf::Image>("Grafik/Ergaenzung.png"), (x-1)*300, y*300, sf::IntRect(0,0,0,0), true);
						renderedTempImage.copy(RM().get<sf::Image>("Grafik/Ergaenzung.png"), (x-1)*300, y*300, sf::IntRect(0,0,0,0), true);
					}
				}
				if(str.find("|") != -1) {
					str = str.substr(3);
				}
				iss.clear();
			}
		}
		renderedImage.loadFromImage(renderedTempImage);
		Sp.setTexture(renderedImage, true);
	}
	catch(...) {
		return false;
	}
	ifs.close();

	return true;
}
