#include <SFML/System.hpp>
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>
#include <SFML/Window.hpp>
#include <fstream>
#include "Utils.h"
#include "Util.h"
#include "Button.h"
#include "Karte.h"
#include "CheckBox.h"


//Ranking
Ranking<float> Rank;
sf::Text Scores[10];

//Sounds
sf::Sound Zndung(RM().get<sf::SoundBuffer>("Sound/Zuendung.ogg")), Brumm(RM().get<sf::SoundBuffer>("Sound/Brumm.ogg")); bool gebrummt = false;
//State-System
enum STATES {MENU, COUNTER, RENNEN, VERLOREN, HIGHSCORE, ENDE};
STATES Status = MENU;

//Init Time-System
sf::Clock Uhr;
unsigned int Count;
Clock Timer(500);

//Fenster einrichten
sf::Vector2f Resolution((float)sf::VideoMode::getDesktopMode().width, (float)sf::VideoMode::getDesktopMode().height);
sf::RenderWindow RW(sf::VideoMode::getDesktopMode(), "Mr. X' Racer", sf::Style::Fullscreen, sf::ContextSettings(0, 0, 4));
sf::Event EV;
sf::View KartenView(sf::FloatRect(-Resolution.x/2, -Resolution.y/2, Resolution.x/2, Resolution.y/2));
const sf::View& DefaultView = RW.getDefaultView();

//Men2 initialisieren
CheckBox CB0(sf::Vector2f(10, Resolution.y/2 - 15), "Lila (Schnell aber schlechte Lenkung)", 2, 15, false);
CheckBox CB1(sf::Vector2f(10, Resolution.y/2 + 15), "Grn (Gute Lenkung aber langsam)");
CheckBoxGroup LilaGrn({ &CB0, &CB1 });
Button BT_MEnde("Beenden (Esc)", sf::Vector2f(Resolution.x/2-150, 25), sf::Vector2f(300, 75));
Button BT_SEnde("Beenden (Esc)", sf::Vector2f(Resolution.x/2-315, 25), sf::Vector2f(300, 75));
Button BT_Men("Hauptmen (M)", sf::Vector2f(Resolution.x/2+15, 25), sf::Vector2f(300, 75));
std::vector<Button> BT_Karten;
sf::Sprite Hintergrund;

//Karte einrichten
Karte Map;

//Autos initialisieren
Auto* sAuto = &Map.Lila;

//Strings...
sf::Text SCount(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
sf::Text SInfo(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
sf::Text Zeit(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
std::string KartenName;

//Index lesen
void ReadKartenIndex() {
	std::ifstream ifs("../../Daten/Mr. X Racer/Karten/Karten.index");
	std::string buffer;
	int i = 1;
	while(ifs.good()) {
		std::getline(ifs, buffer);
		BT_Karten.emplace_back(buffer, sf::Vector2f(Resolution.x/2-250, (float)(i*100+25)), sf::Vector2f(500, 75));
		++i;
	}
	ifs.close();
}

// Karte ffnen
void Start(const std::string& name) {
	KartenName = name;
	if(Map.LoadFile(name)) {
		Zndung.play();
		if(CB0.IsChecked()) {
			sAuto = &Map.Lila;
		}
		else {
			sAuto = &Map.Grn;
		}
		Status = COUNTER;
		Count = 3;
		Uhr.restart();
	}
}

// Process Men
void Men() {
	//Events abfangen
	while(RW.pollEvent(EV)) {
		switch(EV.type) {
			case sf::Event::Closed:
				Status = ENDE;
				return;
			case sf::Event::KeyPressed:
				if(EV.key.code == sf::Keyboard::Escape) {
					Status = ENDE;
					return;
				}
				break;
			case sf::Event::MouseButtonReleased:
				if(EV.mouseButton.button == sf::Mouse::Left) {
					CB0.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y));
					CB1.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y));
					if(BT_MEnde.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = ENDE;
					}
					for(unsigned int i = 0; i < BT_Karten.size(); ++i) {
						if(BT_Karten[i].IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
							Start(BT_Karten[i].getString());
						}
					}
				}
				break;
			default:
				break;
		}
	}

	//Zeichnen
	RW.draw(Hintergrund);
	RW.draw(CB0);
	RW.draw(CB1);
	RW.draw(BT_MEnde);
	for(unsigned int i = 0; i < BT_Karten.size(); ++i) {
		RW.draw(BT_Karten[i]);
	}
}

// Process Counter
void Counter() {
	//Events abfangen
	while(RW.pollEvent(EV)) {
		switch(EV.type) {
			case sf::Event::Closed:
				Status = ENDE;
				return;
			case sf::Event::KeyPressed:
				if(EV.key.code == sf::Keyboard::M) {
					Status = MENU;
					return;
				}
				if(EV.key.code == sf::Keyboard::Escape) {
					Status = ENDE;
					return;
				}
				break;
			case sf::Event::MouseButtonReleased:
				if(EV.mouseButton.button == sf::Mouse::Left) {
					if(BT_SEnde.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = ENDE;
					}
					if(BT_Men.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = MENU;
					}
				}
				break;
			default:
				break;
		}
	}
	//Process Timer
	if(Uhr.getElapsedTime().asSeconds() >= 1) {
		Count--;
		Uhr.restart();
		if(Count <= 0) {
			Status = RENNEN;
		}
	}

	//Zeichnen
	KartenView.setCenter(sAuto->Sp.getPosition());
	RW.setView(KartenView);
	RW.draw(Map);
	RW.draw(*sAuto);
	RW.setView(DefaultView);
	RW.draw(BT_SEnde);
	RW.draw(BT_Men);
	SCount.setString(std::to_string(Count));
	SCount.setPosition(Resolution.x/2 - SCount.getLocalBounds().width/2, Resolution.y/2 - SCount.getLocalBounds().height/2- SCount.getLocalBounds().top-75);
	RW.draw(SInfo);
	RW.draw(SCount);
}

// Process Rennen
void Rennen() {
	//Events abfangen
	while(RW.pollEvent(EV)) {
		switch(EV.type) {
			case sf::Event::Closed:
				Status = ENDE;
				return;
			case sf::Event::KeyPressed:
				if(EV.key.code == sf::Keyboard::Up) {
					if(!gebrummt) {
						Brumm.play();
						gebrummt = true;
					}
				}
				if(EV.key.code == sf::Keyboard::M) {
					Status = MENU;
					return;
				}
				if(EV.key.code == sf::Keyboard::Escape) {
					Status = ENDE;
					return;
				}
				break;
			case sf::Event::KeyReleased:
				if(EV.key.code == sf::Keyboard::Up) {
					gebrummt = false;
				}
			case sf::Event::MouseButtonReleased:
				if(EV.mouseButton.button == sf::Mouse::Left) {
					if(BT_SEnde.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = ENDE;
					}
					if(BT_Men.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = MENU;
					}
				}
				break;
			default:
				break;
		}
	}

	//Nutzereingaben und Rechnen
	if(sf::Keyboard::isKeyPressed(sf::Keyboard::Right)) {
		sAuto->Lenken(true, Timer.GetFrametime());
	}
	if(sf::Keyboard::isKeyPressed(sf::Keyboard::Left)) {
		sAuto->Lenken(false, Timer.GetFrametime());
	}
	sAuto->Beschleunigen(sf::Keyboard::isKeyPressed(sf::Keyboard::Up) || sf::Keyboard::isKeyPressed(sf::Keyboard::Down), sf::Keyboard::isKeyPressed(sf::Keyboard::Up), Timer.GetFrametime());
	sAuto->move(Timer.GetFrametime());
	sf::Vector2<bool> Erg = Map.Kollision(*sAuto);
	if(Erg.y) { //Ziel
		Status = HIGHSCORE;
		while(Rank.size() > 0) {
			Rank.pop_back();
		}
		Rank.ReadFromFile("../../Daten/Mr. X Racer/Karten/" + KartenName + ".rank");
		Rank.Insert(RankValue<float>(Uhr.getElapsedTime().asSeconds(), std::emptyString));
		while(Rank.size() > 10) {
			Rank.pop_back();
		}
		Rank.SaveToFile("../../Daten/Mr. X Racer/Karten/" + KartenName + ".rank");
	}
	else if(Erg.x) { //Bande
		Status = VERLOREN;
	}

	//Zeichnen
	KartenView.setCenter(sAuto->Sp.getPosition());
	RW.setView(KartenView);
	RW.draw(Map);
	RW.draw(*sAuto);
	RW.setView(DefaultView);
	RW.draw(BT_SEnde);
	RW.draw(BT_Men);
	Zeit.setString("Abgelaufene Zeit: " + zeitToString(Uhr.getElapsedTime().asMilliseconds()));
	Zeit.setPosition(Resolution.x - Zeit.getLocalBounds().width - 5, Resolution.y - Zeit.getLocalBounds().height - 5);
	RW.draw(Zeit);
}

//Verloren
void Verloren() {
	//Events abfangen
	while(RW.pollEvent(EV)) {
		switch(EV.type) {
			case sf::Event::Closed:
				Status = ENDE;
				return;
			case sf::Event::KeyPressed:
				if(EV.key.code == sf::Keyboard::Escape) {
					Status = ENDE;
					return;
				}
				if(EV.key.code == sf::Keyboard::M) {
					Status = MENU;
					return;
				}
				break;
			case sf::Event::MouseButtonReleased:
				if(EV.mouseButton.button == sf::Mouse::Left) {
					if(BT_SEnde.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = ENDE;
					}
					if(BT_Men.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = MENU;
					}
				}
				break;
			default:
				break;
		}
	}

	//Zeichnen
	sf::Text Verl("Verloren!", RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Verl.setCharacterSize(100);
	Verl.setColor(sf::Color::Red);
	Verl.setPosition(Resolution.x/2 - Verl.getLocalBounds().width/2, Resolution.y/2 - Verl.getLocalBounds().height/2 - Verl.getLocalBounds().top);
	RW.draw(Verl);
	RW.draw(BT_SEnde);
	RW.draw(BT_Men);
}

//Highscore
void Highscore() {
	//Events abfangen
	while(RW.pollEvent(EV)) {
		switch(EV.type) {
			case sf::Event::Closed:
				Status = ENDE;
				return;
			case sf::Event::KeyPressed:
				if(EV.key.code == sf::Keyboard::Escape) {
					Status = ENDE;
					return;
				}
				if(EV.key.code == sf::Keyboard::M) {
					Status = MENU;
					return;
				}
				break;
			case sf::Event::MouseButtonReleased:
				if(EV.mouseButton.button == sf::Mouse::Left) {
					if(BT_SEnde.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = ENDE;
					}
					if(BT_Men.IsClicked(sf::Vector2i(EV.mouseButton.x, EV.mouseButton.y))) {
						Status = MENU;
					}
				}
				break;
			default:
				break;
		}
	}

	//Zeichnen
	for(unsigned int i = 0; i < Rank.size(); ++i) {
		Scores[i].setFont(RM().get<sf::Font>("../Fonts/sansation.ttf"));
		Scores[i].setString(zeitToString(Rank[i].Value*1000.f));
		Scores[i].setPosition(Resolution.x/2 - Scores[i].getLocalBounds().width/2, (float)(200 + 30*i));
		RW.draw(Scores[i]);
	}
	RW.draw(BT_SEnde);
	RW.draw(BT_Men);
}

//Einsprungpunkt
int main() {
	std::srand(static_cast<unsigned int>(std::time(nullptr)));

	Rank.SetSortOrder(false);

	//Autos einrichten
	Map.Grn.Init(true);
	Map.Lila.Init(false);

	//Fenster einrichten
	RW.setVerticalSyncEnabled(true);

	//Men initialisieren
	sf::Texture& tHintergrund = RM().get<sf::Texture>("Grafik/Hintergrund.png");
	tHintergrund.setSmooth(true);
	Hintergrund.setTexture(tHintergrund);
	Hintergrund.setScale(Resolution.x / tHintergrund.getSize().x, Resolution.y / tHintergrund.getSize().y);
	ReadKartenIndex();

	//Strings initialisieren
	SInfo.setString("  Bringen Sie das Auto schnell\nund UNBESCHDIGT ans Ziel!");
	SInfo.setCharacterSize(70);
	SInfo.setPosition(Resolution.x/2 - SInfo.getLocalBounds().width/2, Resolution.y/2 - SInfo.getLocalBounds().height/2+130);
	SInfo.setColor(sf::Color(30,30,30,225));
	SCount.setCharacterSize(300);
	SCount.setColor(sf::Color(90,80,80,225));
	Zeit.setCharacterSize(30);
	Zeit.setColor(sf::Color(255,255,255,225));

	//Hauptschleife
	while(Status != ENDE) {
		Timer.Refresh();

		switch(Status) {
			case MENU:
				Men();
				break;
			case COUNTER:
				Counter();
				break;
			case RENNEN:
				Rennen();
				break;
			case HIGHSCORE:
				Highscore();
				break;
			case VERLOREN:
				Verloren();
				break;
			default:
				break;
		}

		RW.draw(Timer);
		RW.display();
		RW.clear(sf::Color(70, 115, 9));
	}
	return(0);
}
