#include "ParticleSystem.h"
#include <cmath>


Partikel::Partikel(Dust *owner, float angle, sf::Vector2f pos)
	: sf::RectangleShape(sf::Vector2f(Random(15, 30) / 10.f, Random(15, 30) / 10.f))
	, Angle(angle), LifeTime(0), Owner(owner)
{
	setPosition(pos);
	rotate((float)Random(0, 360));
	setFillColor(RandomGrey());
}

bool Partikel::Process(sf::Int32 ElapsedTime, float Speed) {
	LifeTime += ElapsedTime;
	if (LifeTime > 7500 || getFillColor().a == 0)
		return true;

	Angle += Random(-5, 5);
	move(CreateVector(Angle, ((float)ElapsedTime)*Speed/1000.f));
	return false;
}

void Partikel::DecreaseAlpha() {
	sf::Color x = getFillColor();
	x.a -= std::min<sf::Uint8>(1, x.a);
	setFillColor(x);
}


void Dust::New() {
	Sprites.emplace_back(this, Angle + Random(-50, 50), Position);
}

void Dust::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	for(std::list<Partikel>::const_reverse_iterator i = Sprites.rbegin(); i != Sprites.rend(); ++i) {
		Target.draw(*i, states);
	}
}

void Dust::Run(sf::Int32 time) {
	ElapsedFadeOut += time;
	ElapsedCreator += time;
	for (std::list<Partikel>::iterator i = Sprites.begin(); i != Sprites.end();) {
		if (i->Process(time, Speed + (float)Random(-Speed, Speed)/2.f))
			i = Sprites.erase(i);
		else
			++i;
	}
	if (ElapsedFadeOut > 50) {
		for(std::list<Partikel>::iterator i = Sprites.begin(); i != Sprites.end(); ++i) {
			i->DecreaseAlpha();
		}
		ElapsedFadeOut -= 50;
	}
	if (ElapsedCreator > 1) {
		New();
		ElapsedCreator -= 1;
	}
}

Dust::Dust()
	: ElapsedFadeOut(0), ElapsedCreator(0), Angle(0.f)
{
}


const float Dust::Speed = 7;
