#include "Utils.h"
#include <cmath>

sf::Color RandomGrey() {
	sf::Uint8 i = static_cast<sf::Uint8>(Random(80, 180));
	return(sf::Color(i, i, i, static_cast<sf::Uint8>(Random(30, 150))));
}

sf::Vector2f CreateVector(float Angle, float Speed) {
	return(sf::Vector2f(-Speed * std::sin(degtorad(Angle)), -Speed * std::cos(degtorad(Angle))));
}

Resourcemanager& RM()
{
	static Resourcemanager rm("../../Daten/Mr. X Racer/");
	return rm;
}


Clock::Clock(sf::Int32 RefreshTime)
	: refresh(RefreshTime), Framerate(0), SinceLastRefresh(0), Frametime(0), Counter(0)
{
}
void Clock::Refresh() {
	Frametime = timer.getElapsedTime().asMilliseconds();
	timer.restart();
	SinceLastRefresh += Frametime;
	++Counter;
	if(SinceLastRefresh >= refresh) {
		Framerate = Counter * 1000 / SinceLastRefresh;
		SinceLastRefresh = 0;
		Counter = 0;
	}
}
const sf::Int32& Clock::GetFrametime() const {
	return(Frametime);
}
void Clock::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	sf::Text Str(std::to_string(Framerate), RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Str.setCharacterSize(15);
	Str.setColor(sf::Color::Green);
	Str.setPosition(sf::Vector2f(5, 5));
	Target.draw(Str, states);
}

std::string zeitToString(std::time_t zeit) {
	std::ostringstream os;
	os << zeit/1000;
	os << ':';
	std::time_t centisekunden = (zeit / 10) % 100;
	if (centisekunden < 10)
		os << '0';
	os << centisekunden;
	return os.str();
}
