#include "Gegner.h"
#include "Ressourcen.h"
#include <cmath>


void Gegner::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Sp, states);
}

Gegner::Gegner(const sf::Vector2f& Ziel) : Sp(RM().get<sf::Texture>("Grafik/Gegner.png")), Leben(20.f) {
	Vorat.Add(&Projektil::Typ::Laser, 20);
	setOrigin(Sp.getTexture()->getSize().x/2, Sp.getTexture()->getSize().y/2);
	int32_t x;
	int32_t y;
	if(std::rand()%2 == 0) {
		x = std::rand()%2==0?-6000:6000;
		y = std::rand()%12000-6000;
	}
	else {
		x = std::rand()%12000-6000;
		y = std::rand()%2==0?-6000:6000;
	}
	setPosition((float)x, (float)y);
	Bewegung.v = (float)(2+std::rand()%5);
	Bewegung.Alpha = radtodeg(atan2(Ziel.x - x, Ziel.y - y)) + Random(-5.f, 5.f);
	setRotation(-Bewegung.Alpha);
}

std::pair<bool, Projektil*> Gegner::Run(float Time, const sf::Vector2f& Ziel) {
	std::pair<bool, Projektil*> retVal(false, nullptr);
	if(Leben <= 0) {
		Punkte += 20;
		retVal.first = true;
	}
	else
		retVal.first = Flugobjekt::Run(Time);
	if(!retVal.first) {
		// Drehen
		float xDist = Ziel.x - getPosition().x;
		float yDist = Ziel.y - getPosition().y;
		float distance = std::sqrt(xDist*xDist + yDist*yDist);

		if(distance <= 2000.f) { // Schieen
			setRotation(-radtodeg(atan2(xDist, yDist)));

			if(distance <= 300.f && Schussuhr.getElapsedTime().asMilliseconds() > 1500) {
				Schussuhr.restart();
				Projektil* P = Vorat(getPosition(), Bewegung, getRotation());
				retVal.second = P;
			}
		}
	}
	return(retVal);
}

const sf::Vector2i& Gegner::GetSize() const {
	static sf::Vector2i retVal(Sp.getTexture()->getSize().x, Sp.getTexture()->getSize().y);
	return(retVal);
}
