#include "Ressourcen.h"
#include "SpaceShooter.h"
#include "Util.h"
#include <cstdlib>
#include <fstream>


Spielstatus Status = SPIEL;
int32_t Punkte = 0;

int main() {
	std::srand(static_cast<unsigned int>(std::time(0)));

	sf::RenderWindow RW(sf::VideoMode(1024,768), "SpaceShooter", sf::Style::Close, sf::ContextSettings(0, 0, 4));
	RW.setFramerateLimit(100);
	bool Running = true;
	sf::Event EV;

	SpaceShooter* Spiel = new SpaceShooter();

	sf::Sprite Hintergrund(RM().get<sf::Texture>("Grafik/Hintergrund.png"));

#ifdef DEBUG
	sf::Text FPS(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
	FPS.setPosition(10, 180);
	sf::Text Projektile(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Projektile.setPosition(10,45);
	sf::Text Gegner(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Gegner.setPosition(10,90);
	sf::Text PUs(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
	PUs.setPosition(10,135);
#endif
	sf::Text tPunkte("Punkte: 0", RM().get<sf::Font>("../Fonts/sansation.ttf"));
	tPunkte.setPosition(10, 5);
	tPunkte.setColor(sf::Color(50,225,50,200));
	sf::Text GameOver("Ihr Raumschiff wurde zerstrt!", RM().get<sf::Font>("../Fonts/sansation.ttf"));
	GameOver.setCharacterSize(75);
	GameOver.setPosition(512 - GameOver.getLocalBounds().width/2, 380 - GameOver.getLocalBounds().height);
	GameOver.setColor(sf::Color(240, 25, 25, 200));
	sf::Text Erreichtes(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
	Erreichtes.setColor(sf::Color(225, 225, 25));
	Erreichtes.setCharacterSize(40);
	sf::Text CountDown(sf::emptyString, RM().get<sf::Font>("../Fonts/sansation.ttf"));
	CountDown.setCharacterSize(100);
	CountDown.setPosition(512 - CountDown.getLocalBounds().width/2, 390);
	CountDown.setColor(sf::Color(25, 240, 25, 200));
	int8_t Zhler = -1;
	sf::Clock Uhr, Timer;

	bool Umschalttaste = false;
	while(Running) {
		while(RW.pollEvent(EV)) {
			switch(EV.type) {
				case sf::Event::Closed:
					Running = false;
					break;
				case sf::Event::KeyPressed:
					switch(EV.key.code) {
						case sf::Keyboard::Escape:
							Running = false;
							break;
						case sf::Keyboard::RShift: case sf::Keyboard::LShift:
							Umschalttaste = true;
							break;
					}
					break;
			}
		}

		if(Status == SPIEL) {
			Spiel->Run(Umschalttaste, Timer.getElapsedTime().asSeconds());
			Timer.restart();
			Umschalttaste = false;
		}
		else {
			if(Zhler == -1) {
				delete Spiel;
				Spiel = 0;
				Uhr.restart();
				Zhler = 5;
				// Highscore
				std::ifstream ifs("../../Daten/Spaceshooter/Highscore.txt");
				if(!ifs.good()) {
					ifs.close();
					if(Punkte > 0)
						Erreichtes.setString("Frs erste Mal: Nicht schlecht.");
					else
						Erreichtes.setString("Naja, sie msssen noch ben.");
					std::ofstream ofs("../../Daten/Spaceshooter/Highscore.txt");
					ofs << Punkte;
				}
				else {
					int32_t Bestwert;
					ifs >> Bestwert;
					ifs.close();
					if(Bestwert >= Punkte) {
						if(Punkte < 0) {
							Erreichtes.setString("Ihre Leistung war katastrophal. Sie mssen sich verbessern.");
						}
						else
							Erreichtes.setString("Das knnen Sie besser.");
					}
					else {
						Erreichtes.setString("Gratulation! Sie haben eine neue Bestleistung erzielt.");
						std::ofstream ofs("../../Daten/Spaceshooter/Highscore.txt");
						ofs << Punkte;
					}
				}
				Erreichtes.setPosition(1024.f/2.f-Erreichtes.getLocalBounds().width/2, 768-5-Erreichtes.getLocalBounds().height);
			}
			if(Uhr.getElapsedTime().asMilliseconds() > 1.f) {
				if(Zhler == 0) {
					Status = SPIEL;
					Spiel = new SpaceShooter();
					Punkte = 0;
					Zhler = -1;
					continue;
				}
				Uhr.restart();
				Zhler--;
			}
			CountDown.setString(std::to_string(Zhler));
		}

		RW.clear();
		RW.draw(Hintergrund);
		if(Status == SPIEL) {
			RW.draw(*Spiel);
#ifdef DEBUG
			Projektile.setString("Projektile: " + std::to_string(Spiel->Projektile.size()));
			RW.draw(Projektile);
			Gegner.setString("Gegner: " + std::to_string(Spiel->gegner.size()));
			RW.draw(Gegner);
			PUs.setString("PowerUps: " + std::to_string(Spiel->PowerUps.size()));
			RW.draw(PUs);
			static sf::Clock FPS_Uhr;
			if(FPS_Uhr.getElapsedTime().asSeconds() >= 0.1f) {
				FPS.setString("FPS: " + std::to_string(6.f/FPS_Uhr.getElapsedTime().asSeconds()));
				FPS_Uhr.restart();
			}
			RW.draw(FPS);
#endif
		}
		else {
			RW.draw(Erreichtes);
			RW.draw(GameOver);
			RW.draw(CountDown);
		}
		tPunkte.setString("Punkte: " + std::to_string(Punkte));
		RW.draw(tPunkte);
		RW.display();
	}

	delete Spiel;

	return(0);
}
