#include "Pfeil.h"


void Pfeil::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(s1, states);
	Target.draw(s2, states);
	Target.draw(s3, states);
}

Pfeil::Pfeil(const sf::FloatRect& rand)
	: s1(4)
	, s2(4)
	, s3(4)
{
	constexpr int width = 8;
	constexpr int hwidth = width / 2;
	constexpr int twidth = width / 3;
	s1.setFillColor(sf::Color(50, 225, 50, 200));
	s1.setPoint(0, sf::Vector2f(rand.width / 2 - twidth, 0));
	s1.setPoint(1, sf::Vector2f(rand.width / 2 + twidth, 0));
	s1.setPoint(2, sf::Vector2f(rand.width / 2 + twidth, rand.height));
	s1.setPoint(3, sf::Vector2f(rand.width / 2 - twidth, rand.height));

	s2.setFillColor(sf::Color(50, 225, 50, 200));
	s2.setPoint(0, sf::Vector2f(rand.width / 2 - twidth, rand.height - width));
	s2.setPoint(1, sf::Vector2f(rand.width / 2 - twidth, rand.height));
	s2.setPoint(2, sf::Vector2f(0, rand.height * 2 / 5 + hwidth));
	s2.setPoint(3, sf::Vector2f(0, rand.height * 2 / 5 - hwidth));

	s3.setFillColor(sf::Color(50, 225, 50, 200));
	s3.setPoint(0, sf::Vector2f(rand.width / 2 + twidth, rand.height - width));
	s3.setPoint(1, sf::Vector2f(rand.width / 2 + twidth, rand.height));
	s3.setPoint(2, sf::Vector2f(rand.width, rand.height * 2 / 5 + hwidth));
	s3.setPoint(3, sf::Vector2f(rand.width, rand.height * 2 / 5 - hwidth));

	setPosition(rand.left+rand.width/2, rand.top+rand.height/2);
	setOrigin(rand.width/2, rand.height/2);
}
