#include "Projektil.h"
#include "Ressourcen.h"


const Projektil::Typ Projektil::Typ::Kugel("Kugel", 3, 20.f, 100, 0, 1000);
const Projektil::Typ Projektil::Typ::Laser("Laser", 7, 40.f, 200, 0, 200);
const Projektil::Typ Projektil::Typ::Drohne("Drohne", 20, 8.f, 1000, 10000, 5);

Projektil::Typ::Typ(const std::string& name, uint32_t schaden, float fluggeschwindigkeit, uint16_t ladezeit, uint32_t flugzeit, uint16_t maxLager)
	: Name(name), Schaden(schaden), Fluggeschwindigkeit(fluggeschwindigkeit), Ladezeit(ladezeit), Flugzeit(flugzeit), MaxLager(maxLager)
{
}
const sf::Texture& Projektil::Typ::GetImg() const {
	return(RM().get<sf::Texture>("Grafik/M_" + Name + ".png"));
}
const sf::Texture& Projektil::Typ::GetLImg() const {
	return(RM().get<sf::Texture>("Grafik/" + Name + ".png"));
}
const sf::SoundBuffer& Projektil::Typ::GetSchuss() const {
	return(RM().get<sf::SoundBuffer>("Sound/" + Name + ".ogg"));
}



void Projektil::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Sp, states);
}

Projektil::Projektil(const Typ* t) : typ(t), Sp(t->GetImg()), Schuss(t->GetSchuss()) {
	setOrigin(Sp.getTexture()->getSize().x/2, Sp.getTexture()->getSize().y/2);
}

void Projektil::Abschuss() {
	if(typ->Flugzeit > 0)
		Uhr.restart();
}

bool Projektil::Run(float Time) {
	if(typ->Flugzeit > 0) {
		if(Uhr.getElapsedTime().asSeconds() > typ->Flugzeit) {
			return(true);
		}
	}
	return(Flugobjekt::Run(Time));
}

float Projektil::GetSchaden() const {
	return((float)typ->Schaden);
}

const sf::Vector2i& Projektil::GetSize() const {
	static sf::Vector2i retVal(Sp.getTexture()->getSize().x, Sp.getTexture()->getSize().y);
	return(retVal);
}
