#include "Spieler.h"
#include "Ressourcen.h"


void Spieler::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Sp, states);
	if(Vortrieb)
		Target.draw(SP_v, states);
	if(Rcktrieb)
		Target.draw(SP_r, states);
	if(SeittriebR)
		Target.draw(SP_sr, states);
	if(SeittriebL)
		Target.draw(SP_sl, states);
}

Spieler::Spieler()
	: SP_v(RM().get<sf::Texture>("Grafik/SpielerV.png")), SP_r(RM().get<sf::Texture>("Grafik/SpielerR.png")), SP_sr(RM().get<sf::Texture>("Grafik/SpielerSR.png")), SP_sl(RM().get<sf::Texture>("Grafik/SpielerSL.png")), 
	Sp(RM().get<sf::Texture>("Grafik/Spieler.png")), Kamera(sf::FloatRect(0.f,0.f,1024.f,768.f)), Leben(200.f), Treibstoff(100.f), Crash(RM().get<sf::SoundBuffer>("Sound/Crash.ogg")), PowerUpSound(RM().get<sf::SoundBuffer>("Sound/PowerUp.ogg"))
{
	setOrigin(Sp.getTexture()->getSize().x/2, Sp.getTexture()->getSize().y/2);
	setPosition(512, 384);
	setRotation(180);
}

const sf::Vector2i& Spieler::GetSize() const {
	static sf::Vector2i retVal(Sp.getTexture()->getSize().x, Sp.getTexture()->getSize().y);
	return(retVal);
}

void Spieler::Run(float Time) {
	if(Treibstoff > 0) {
		SeittriebL = sf::Keyboard::isKeyPressed(sf::Keyboard::Left);
		if(SeittriebL) {
			rotate(-100.f*Time);
			Treibstoff -= Time;
		}
		SeittriebR = sf::Keyboard::isKeyPressed(sf::Keyboard::Right);
		if(SeittriebR) {
			rotate(100.f*Time);
			Treibstoff -= Time;
		}
		Vortrieb = sf::Keyboard::isKeyPressed(sf::Keyboard::Up);
		if(Vortrieb) {
			Bewegung.Beschleunigen(5.f, Time, getRotation());
			Treibstoff -= 2.5f*Time;
		}
		Rcktrieb = sf::Keyboard::isKeyPressed(sf::Keyboard::Down);
		if(Rcktrieb) {
			Bewegung.Beschleunigen(-3.f, Time, getRotation());
			Treibstoff -= Time;
		}
	}
	else {
		Rcktrieb = false;
		Vortrieb = false;
		SeittriebL = false;
		SeittriebR = false;
	}
	Flugobjekt::Run(Time);
	Kamera.move(static_cast<sf::Vector2f>(Bewegung)*(float)Time*50.f);

	if(getPosition().x < -5000 || getPosition().x > 5000) {
		Leben -= std::pow(std::abs(static_cast<sf::Vector2f>(Bewegung).x), 2)/4.f;
		Flugobjekt::Run(-Time);
		Kamera.move(-static_cast<sf::Vector2f>(Bewegung)*(float)Time*50.f);
		Bewegung.v = 0;
	}
	if(getPosition().y < -5000 || getPosition().y > 5000) {
		Leben -= std::pow(std::abs(static_cast<sf::Vector2f>(Bewegung).y), 2)/4.f;
		Flugobjekt::Run(-Time);
		Kamera.move(-static_cast<sf::Vector2f>(Bewegung)*(float)Time*50.f);
		Bewegung.v = 0;
	}
	if(Leben <= 0)
		Status = GAMEOVER;
}
