#include "Button.h"


Button::Button(const sf::FloatRect& Rect, const std::string& text)
	: Text(text, RM().get<sf::Font>("../Fonts/sansation.ttf"))
	, Size(Rect.width,Rect.height)
	, Border(sf::RectangleShape(sf::Vector2f(Rect.width,Rect.height)))
{
	Border.setFillColor(sf::Color::Transparent);
	Border.setOutlineColor(sf::Color::White);
	Border.setOutlineThickness(5);
	setPosition(Rect.left, Rect.top);
	Text.setPosition((Size.x - Text.getLocalBounds().width) / 2, (Size.y - Text.getCharacterSize() - Text.getLocalBounds().top) / 2);
	Text.setColor(sf::Color::White);

	Ondraw += std::bind(&Button::draw, this, std::placeholders::_1, std::placeholders::_2);
}

void Button::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Text, states);
	Target.draw(Border, states);
}

void Button::setText(const std::string& text) {
	Text.setString(text);
	Text.setPosition((Size.x - Text.getLocalBounds().width) / 2, (Size.y - Text.getCharacterSize() - Text.getLocalBounds().top) / 2);
}

sf::FloatRect Button::getLocalBounds() const {
	return(sf::FloatRect(getPosition(), Size));
}
