#include "Gegner.h"
#include "Ressourcen.h"
#include <cmath>


Gegner Gegner::v1(2, 10*2);
Gegner Gegner::v2(4, 10*3);
Gegner Gegner::v3(6, 10*5);
Gegner Gegner::v4(12, 10*6);
Gegner Gegner::v5(25, 10*2);
uint8_t Gegner::Initialisiert = 6;

void Gegner::Init() {
	v1.setTexture(RM().get<sf::Texture>("Grafik/g1.png"));
	v2.setTexture(RM().get<sf::Texture>("Grafik/g2.png"));
	v2.AddKind(v1);
	v3.setTexture(RM().get<sf::Texture>("Grafik/g3.png"));
	v3.AddKind(v2);
	v4.setTexture(RM().get<sf::Texture>("Grafik/g4.png"));
	v4.AddKind(v3);
	v4.AddKind(v3);
	v5.setTexture(RM().get<sf::Texture>("Grafik/g5.png"));
	v5.AddKind(v4);
	v5.AddKind(v3);
	v5.AddKind(v3);
	v5.AddKind(v2);
	v5.AddKind(v2);
	v5.AddKind(v2);
	v5.AddKind(v1);
	v5.AddKind(v1);
	v5.AddKind(v1);
	v5.AddKind(v1);
	Initialisiert = 0;
}


Gegner::Gegner(uint16_t leben, uint16_t geschwindigkeit)
	: Leben(leben), Geschwindigkeit(geschwindigkeit)
{
	if(Initialisiert > 1) Initialisiert--;
	if(Initialisiert == 1) Init();
}

Gegner::Gegner(const Gegner& Vorlage, const PfadElem* Start)
	: Position(Start), Next(Position->GetRandomNext()), Status(0.f),
	  Leben(Vorlage.Leben), Geschwindigkeit(Vorlage.Geschwindigkeit), Kinder(Vorlage.Kinder), Sp(*Vorlage.Sp.getTexture()) // Von Vorlage "geerbt"
{
	setPosition(static_cast<sf::Vector2f>(Start->Pos));
	setOrigin(Sp.getTexture()->getSize().x/2.f, Sp.getTexture()->getSize().y/2.f);
}

void Gegner::AddKind(const Gegner& g) {
	Gegner G = g; // Kopie erzeugen
	G.setPosition(getPosition());
	Kinder.emplace_back(G);
}

bool Gegner::IsTunnel() const {
	return(Position->Typ == PfadElem::TUNNEL || Position->Typ == PfadElem::TUNNELEA);
}

void Gegner::setTexture(const sf::Texture& Img) {
	Sp.setTexture(Img);
}

bool Gegner::Run(uint32_t Frametime) {
	Status += static_cast<float>(Frametime)*Geschwindigkeit/1000.f;
	if(Next->Pos.x == Position->Pos.x || Next->Pos.y == Position->Pos.y) { // Gerade Bewegung
		if(Status >= 1.f) { // Eins weiter
			Position = Next;
			Next = Position->GetRandomNext();
			if(Next == nullptr) // Ziel erreicht
				return(true);
			setPosition(static_cast<sf::Vector2f>(Position->Pos));
			Status -= 1.f;
		}
	}
	else { // Schrge Bewegung
		if(Status >= std::sqrt(2.f)) { // Eins weiter
			Position = Next;
			Next = Position->GetRandomNext();
			if(Next == nullptr) // Ziel erreicht
				return(true);
			setPosition(static_cast<sf::Vector2f>(Position->Pos));
			Status -= std::sqrt(2.f);
		}
	}
	return(false);
}

bool Gegner::Treffer(uint16_t Schaden, float Verlangsamung) {
	Geschwindigkeit *= Verlangsamung;
	if(Schaden >= Leben) {
		for(auto i = Kinder.begin(); i != Kinder.end(); ++i) { // Kinder vorbereiten
			i->Position = Position;
			i->Next = Next;
			i->Status = Status;
			i->setOrigin(getOrigin());
		}
		return(true);
	}
	Leben -= Schaden;
	return(false);
}

uint16_t Gegner::GetValue() const {
	uint16_t Wert = 1;
	for(auto i = Kinder.cbegin(); i != Kinder.cend(); ++i) {
		Wert += i->GetValue();
	}
	return(Wert);
}

float Gegner::GetRadius() const {
	return(Sp.getTexture()->getSize().x/2.f);
}

void Gegner::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	if(!IsTunnel()) {
		states.transform *= getTransform();
		Target.draw(Sp, states);
	}
}
