#include "Geschoss.h"


Geschoss::Geschoss(const sf::Texture& Img, const sf::Vector2f& Position, float richtung, float geschwindigkeit, uint16_t schaden, uint16_t durchschlag, float verlangsamung)
	: Sp(Img), Bewegung(std::cos(richtung) * geschwindigkeit, std::sin(richtung) * geschwindigkeit), Schaden(schaden), Verlangsamung(verlangsamung), Durchschlag(durchschlag)
{
	setPosition(Position);
	setOrigin(Img.getSize().x/2.f, Img.getSize().y/2.f);
	setRotation(90.f+radtodeg(richtung));
}

bool Geschoss::Run(uint32_t Frametime) {
	if(getPosition().x < 0 || getPosition().x > 800 || getPosition().y < 0 || getPosition().y > 600)
		return(false);
	move(static_cast<float>(Frametime)*Bewegung/1000.f);
	return(true);
}

bool Geschoss::Treffer() {
	Durchschlag--;
	return(Durchschlag == 0);
}

void Geschoss::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Sp, states);
}

float Geschoss::GetRadius() const {
	return(Sp.getTexture()->getSize().x/2.f);
}
