#include "Label.h"


Label::Label(const std::string& text, const sf::Color& color)
	: Text(text, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	Text.setCharacterSize(80);
	Text.setColor(color);
	Text.setOrigin(Text.getLocalBounds().width/2, Text.getLocalBounds().height/2);
	Ondraw += std::bind(&Label::draw, this, std::placeholders::_1, std::placeholders::_2);
}

void Label::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Text, states);
}

sf::FloatRect Label::getLocalBounds() const {
	return(Text.getLocalBounds());
}
