#include "Status.h"
#include "Spiel.h"
#include "Button.h"
#include "Window.h"
#include "Label.h"
#include "ValueBoundLabel.h"
#include "Shell.h"
#include <cstdlib>
#include <fstream>


Spiel* TowerDefense = nullptr;

Window RW(sf::VideoMode(800,600), "Tower Defense", sf::Style::Close);
Button bSpeichern(sf::FloatRect(180,310,230,75), "Spiel speichern");
Button bSchlieen(sf::FloatRect(430,310,190,75), "Schlieen");
Button bSpielNeu(sf::FloatRect(190,210,200,75), "Neues Spiel");
Button bSpielLaden(sf::FloatRect(410,210,200,75), "Spiel laden");
Button bMen(sf::FloatRect(665,60,120,50), "Men");
Button bStart(sf::FloatRect(15, 535, 120, 50), "Start");
ValueBoundLabel<int16_t> vLeben(Leben, "Leben: ");
ValueBoundLabel<uint16_t> vGeld(Geld, "Geld: "), vLevel(Level, "Level: ");
Label Verloren("Verloren", sf::Color::Red);
Label Gewonnen("Gewonnen", sf::Color::Green);

Shell shell("../../Daten/Tower Defense/Hilfe", "Willkommen in der Kommandozeilenhilfeschnittstelle von Tower Defense.\n\nGeben Sie \"?\" ein, um weitere Informationen zu bekommen.");

void SetVBLPos() {
	vGeld.setPosition(525-vGeld.getLocalBounds().width/2, 5);
	vLevel.setPosition(800-15-vGeld.getLocalBounds().width, 5);
}

void close() {
	SetStatus(ENDE);
	RW.close();
	delete TowerDefense;
	exit(0); // HACK
}

void Schlieen(const sf::Vector2i&, sf::Mouse::Button) {
	close();
}

void Speichern(const sf::Vector2i&, sf::Mouse::Button) {
	std::ofstream ofs("../../Daten/Tower Defense/Level/Level.Status");
	ofs << Level << std::endl;
	ofs << Geld << std::endl;
	ofs << Leben;
}

void NeuesSpiel() {
	delete TowerDefense;
	TowerDefense = new Spiel();
	RW.clearChilds();
	bStart.setText("Start");
	RW += TowerDefense;
	RW += bMen;
	RW += bStart;
	RW += vLeben;
	RW += vGeld;
	RW += vLevel;
}

void Pause() {
	if(GetStatus() == LEVEL) {
		if(TowerDefense->IsPaused()) {
			TowerDefense->Continue();
			bStart.setText("Pause");
		}
		else {
			TowerDefense->Pause();
			bStart.setText("Weiter");
		}
	}
}

void Start(const sf::Vector2i&, sf::Mouse::Button) {
	if(GetStatus() == LEVEL) {
		Pause();
	}
	else {
		SetStatus(LEVEL);
		bStart.setText("Pause");
		TowerDefense->Continue();
	}
}

void SpielNeu(const sf::Vector2i&, sf::Mouse::Button) {
	Level = 1;
	Leben = 25;
	Geld = 50;
	NeuesSpiel();
}

void SpielLaden(const sf::Vector2i&, sf::Mouse::Button) {
	Level = 0;
	NeuesSpiel();
}

void Men() {
	SetStatus(MEN);
	RW.clearChilds();
	RW += bSpeichern;
	RW += bSchlieen;
	RW += bSpielNeu;
	RW += bSpielLaden;
	RW += vLeben;
	RW += vGeld;
	RW += vLevel;
	delete TowerDefense;
	TowerDefense = 0;
}

void fMen(const sf::Vector2i&, sf::Mouse::Button) {
	Men();
}

void KeyUp(sf::Keyboard::Key Key) {
	switch(Key) {
		case sf::Keyboard::Escape:
			close();
			break;
		case sf::Keyboard::M:
			if(GetStatus() != MEN)
				Men();
			break;
		case sf::Keyboard::Pause:
			Pause();
			break;
		default:
			if(TowerDefense != nullptr)
				TowerDefense->KeyPressed(Key);
			break;
	}
}


int main() {
	std::srand(static_cast<unsigned int>(std::time(nullptr)));

	shell.AddCommand("?", std::bind(&Shell::operator(), &shell, "Hilfe"));
	shell.AddCommand("Beenden", &close);

	Verloren.setPosition(400,300);
	Gewonnen.setPosition(400,300);

	RW.Onclose += &close;
	RW.OnKeyUp += &KeyUp;
	
	bSchlieen.OnMouseButtonUp += &Schlieen;
	bSpeichern.OnMouseButtonUp += &Speichern;
	bSpielNeu.OnMouseButtonUp += &SpielNeu;
	bSpielLaden.OnMouseButtonUp += &SpielLaden;
	bMen.OnMouseButtonUp += &fMen;
	bStart.OnMouseButtonUp += &Start;

	vLeben.setPosition(250,5);
	vGeld.OnTextUpdate += &SetVBLPos;
	vLevel.OnTextUpdate += &SetVBLPos;
	SetVBLPos();

	Men();

	sf::Clock Timer;

	while(GetStatus() != ENDE) {
		RW.HandleEvents();

		if(GetStatus() == LEVEL && !TowerDefense->IsPaused()) {
			if(TowerDefense->Run(Timer.getElapsedTime().asMilliseconds())) {
				if(!TowerDefense->NextLevel()) { // DURCHGESPIELT
					RW.clearChilds();
					RW += bMen;
					RW += Gewonnen;
				}
				else {
					Geld += 25;
					bStart.setText("Start");
				}
			}
			Timer.restart();
			if(GetStatus() == VERLOREN) { // Gesetzt durch TowerDefense->Run
				RW.clearChilds();
				RW += bMen;
				RW += Verloren;
			}
		}

		if(GetStatus() != ENDE)
			RW.display();
	}

	return(0);
}
