#ifndef SHELL_H
#define SHELL_H

#include "Global.h"
#include <unordered_map>
#include <functional>
#include <string>
#include <iostream>


class Shell {
	std::string Prompt;
	std::string Folder;
	std::unordered_map<std::string, std::function<void(void)>> CommandTable;
	sf::Thread Thr;

	void Run() const;
	void displayText(const std::string& name) const;
	void Execute(const std::string& command) const;
public:
	Shell(const char* folder, const char* Welcome, const char* prompt = "$> ");
	~Shell();
	void operator()(const std::string& command) const;
	const Shell& operator<<(const std::string& string) const;
	void AddCommand(const char* command, std::function<void(void)> func);
};


#endif
