#include "Spiel.h"
#include "Ressourcen.h"
#include "Status.h"
#include <fstream>
#include <functional>
#include <cstdlib>


uint16_t Level = 0;
uint16_t Geld = 50;
int16_t Leben = 25;


Spiel::Spiel() : Pusher(std::bind(&Spiel::fPusher, this)), Paused(true), GewhlterTurmtyp(0), LevelFertig(false), pKarte(new PfadKarte()) {
	SetStatus(BAUPAUSE);

	if(Level == 0) {
		std::ifstream ifs("../../Daten/Tower Defense/Level/Level.Status");
		if(ifs.good()) {
			ifs >> Level;
			ifs >> Geld;
			ifs >> Leben;
		}
		else {
			Level = 1;
			Geld = 50;
			Leben = 25;
		}
	}
	std::ifstream ifs("../../Daten/Tower Defense/Level/" + std::to_string(Level) + ".Level");
	std::string Pfad;
	ifs >> Pfad;
	ifs >> Pfad;
	pKarte->Load(RM().get<sf::Image>("Level/" + Pfad));
	ifs >> Pfad;
	Hintergrund.setTexture(RM().get<sf::Texture>("Level/" + Pfad));

	Pauser.lock();
	Pusher.launch();

	Ondraw += std::bind(&Spiel::draw, this, std::placeholders::_1, std::placeholders::_2);
	OnMouseMove += std::bind(&Spiel::MouseMove, this, std::placeholders::_1);
	OnMouseButtonUp += std::bind(&Spiel::MouseButtonUp, this, std::placeholders::_1, std::placeholders::_2);
}

Spiel::~Spiel() {
	Pusher.terminate();
	for(auto i = Geschosse.begin(); i != Geschosse.end(); ++i)
		delete *i;
}

void Spiel::fPusher() {
	std::srand(static_cast<unsigned int>(std::time(nullptr)));

	std::ifstream ifs("../../Daten/Tower Defense/Level/" + std::to_string(Level) + ".Level");
	std::string temp;
	ifs >> temp;
	ifs >> temp;
	ifs >> temp;
	do {
		Pauser.lock();
		Pauser.unlock();
		char c = 0;
		ifs.get(c);
		switch(c) {
			case '1':
				gegner.emplace_back(Gegner::v1, pKarte->Start.GetRandomNext());
				break;
			case '2':
				gegner.emplace_back(Gegner::v2, pKarte->Start.GetRandomNext());
				break;
			case '3':
				gegner.emplace_back(Gegner::v3, pKarte->Start.GetRandomNext());
				break;
			case '4':
				gegner.emplace_back(Gegner::v4, pKarte->Start.GetRandomNext());
				break;
			case '5':
				gegner.emplace_back(Gegner::v5, pKarte->Start.GetRandomNext());
				break;
			case '#':
				sf::sleep(sf::seconds(4));
				break;
			case '\n':
				sf::sleep(sf::milliseconds(800));
				break;
		}
		if(!ifs.good())
			LevelFertig = true;
		sf::sleep(sf::milliseconds(400));
	} while(GetStatus() == LEVEL);
}

bool Spiel::NextLevel() {
	GewhlterTurmtyp = 0;
	SetStatus(BAUPAUSE);
	Level++;
	LevelFertig = false;
	
	for(auto i = Geschosse.begin(); i != Geschosse.end(); ++i)
		delete *i;
	Geschosse.clear();

	std::ifstream ifs("../../Daten/Tower Defense/Level/" + std::to_string(Level) + ".Level");
	if(!ifs.good()) {
		SetStatus(DURCHGESPIELT);
		return(false);
	}
	std::string Pfad;
	ifs >> Pfad;
	if(Pfad != "0") Trme.clear();
	ifs >> Pfad;
	delete pKarte;
	pKarte = new PfadKarte();
	pKarte->Load(RM().get<sf::Image>("Level/" + Pfad));
	ifs >> Pfad;
	Hintergrund.setTexture(RM().get<sf::Texture>("Level/" + Pfad));

	Pauser.lock();
	Pusher.launch();
	return(true);
}

sf::FloatRect Spiel::getLocalBounds() const {
	static const sf::FloatRect R(0,0,800,600);
	return(R);
}

void Spiel::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Hintergrund, states);
	for(auto i = Trme.cbegin(); i != Trme.cend(); ++i)
		Target.draw(*i, states);
	for(auto i = Geschosse.cbegin(); i != Geschosse.cend(); ++i)
		Target.draw(**i, states);
	for(auto i = gegner.cbegin(); i != gegner.cend(); ++i)
		Target.draw(*i, states);
	if(GewhlterTurmtyp != 0 && pKarte->Img->getPixel(Turm::Trme[GewhlterTurmtyp-1].getPosition().x, Turm::Trme[GewhlterTurmtyp-1].getPosition().y) == sf::Color::Green)
		Target.draw(Turm::Trme[GewhlterTurmtyp-1], states);
}

void Spiel::MouseMove(const sf::Vector2i& Pos) {
	if(GewhlterTurmtyp != 0)
		Turm::Trme[GewhlterTurmtyp-1].setPosition(static_cast<sf::Vector2f>(Pos));
}

void Spiel::MouseButtonUp(const sf::Vector2i&, sf::Mouse::Button Button) {
	if(GewhlterTurmtyp != 0) {
		if(Button == sf::Mouse::Left) {
			if(Geld >= Turm::Trme[GewhlterTurmtyp-1].Preis && pKarte->Img->getPixel(Turm::Trme[GewhlterTurmtyp-1].getPosition().x, Turm::Trme[GewhlterTurmtyp-1].getPosition().y) == sf::Color::Green) {
				Geld -= Turm::Trme[GewhlterTurmtyp-1].Preis;
				Trme.emplace_back(GewhlterTurmtyp-1);
				GewhlterTurmtyp = 0;
			}
		}
		else if(Button == sf::Mouse::Right) {
			GewhlterTurmtyp = 0;
		}
	}
}

void Spiel::KeyPressed(sf::Keyboard::Key Taste) {
	switch(Taste) {
		case sf::Keyboard::Num1:
			GewhlterTurmtyp = 1;
			break;
		case sf::Keyboard::Num2:
			GewhlterTurmtyp = 2;
			break;
		case sf::Keyboard::Num3:
			GewhlterTurmtyp = 3;
			break;
		case sf::Keyboard::Num4:
			GewhlterTurmtyp = 4;
			break;
	}
}

bool Spiel::Run(uint32_t Frametime) {
	for(auto i = gegner.begin(); i != gegner.end();) {
		if(!i->IsTunnel()) {
			sf::Vector2i Pos(i->getPosition());
			for(auto j = Trme.begin(); j != Trme.end(); ++j) {
				if(i->Geschwindigkeit > 10 || j->Schaden != 0) {
					Geschoss* G = j->Schiee(Pos);
					if(G != nullptr) {
						Geschosse.push_back(G);
						continue;
					}
				}
			}
		}
		bool gelscht = false;
		for(auto j = Geschosse.begin(); j != Geschosse.end();) {
			if((i->Geschwindigkeit > 10 || (*j)->Schaden != 0) && CircleCollision((*j)->getPosition(), (*j)->GetRadius(), i->getPosition(), i->GetRadius())) {
				if(i->Treffer((*j)->Schaden, (*j)->Verlangsamung)) {
					gegner.insert(gegner.begin(), i->Kinder.cbegin(), i->Kinder.cend());
					gelscht = true;
					i = gegner.erase(i);
					Geld++;
				}
				if((*j)->Treffer()) {
					delete *j;
					j = Geschosse.erase(j);
				}
				if(gelscht)
					break;
			}
			else
				++j;
		}
		if(!gelscht && i->Run(Frametime)) { // Ziel erreicht
			Leben -= i->GetValue();
			i = gegner.erase(i);
		}
		else if(!gelscht)
			++i;
	}
	for(auto i = Geschosse.begin(); i != Geschosse.end();) {
		if((*i)->Run(Frametime))
			++i;
		else
			i = Geschosse.erase(i);
	}
	if(Leben < 0) {
		SetStatus(VERLOREN);
		return(false);
	}
	return(LevelFertig && gegner.empty());
}

void Spiel::Pause() {
	Pauser.lock();
	Paused = true;
}

void Spiel::Continue() {
	Pauser.unlock();
	Paused = false;
}

bool Spiel::IsPaused() const {
	return(Paused);
}
