#include "Turm.h"
#include "Ressourcen.h"
#include <cmath>
#include "SoundPlayer.h"

Turm Turm::Trme[4] = {Turm(RM().get<sf::Texture>("Grafik/t1.png"), RM().get<sf::Texture>("Grafik/t1g.png"), RM().get<sf::SoundBuffer>("Sound/t1.ogg"), sf::Vector2f(15.f,15.f), 40, 80, 2150, 200, 3, 10),			// Kanone
					   Turm(RM().get<sf::Texture>("Grafik/t2.png"), RM().get<sf::Texture>("Grafik/t2g.png"), RM().get<sf::SoundBuffer>("Sound/t2.ogg"), sf::Vector2f(12.f,12.f), 40, 60, 1100, 100, 1, 0, 0.75f),	// Kleber
                       Turm(RM().get<sf::Texture>("Grafik/t3.png"), RM().get<sf::Texture>("Grafik/t3g.png"), RM().get<sf::SoundBuffer>("Sound/t3.ogg"), sf::Vector2f(13.f,13.f), 100, 90, 150, 300, 1, 1),			// Maschinengewehr
                       Turm(RM().get<sf::Texture>("Grafik/t4.png"), RM().get<sf::Texture>("Grafik/t4g.png"), RM().get<sf::SoundBuffer>("Sound/t4.ogg"), sf::Vector2f(12.f,12.f), 200, 150, 1300, 500, 10, 5)};		// Laser


Turm::Turm(const sf::Texture& Img, const sf::Texture& gImg, const sf::SoundBuffer& schuss, const sf::Vector2f& Mitte, uint16_t preis, uint16_t reichweite, uint32_t ladezeit, uint16_t schussgeschw, uint16_t durchschlag, uint16_t schaden, float verlangsamung)
	: Sp(Img), GImg(gImg), Schuss(schuss), Preis(preis), Reichweite(reichweite), Ladezeit(ladezeit), Schussgeschw(schussgeschw), Durchschlag(durchschlag), Schaden(schaden), Verlangsamung(verlangsamung),
	Kreis(new sf::CircleShape(reichweite))
{
	Kreis->setPosition(-reichweite, -reichweite);
	Kreis->setFillColor(sf::Color::Transparent);
	Kreis->setOutlineColor(sf::Color(200,200,200,200));
	Kreis->setOutlineThickness(2);
	Sp.setOrigin(Mitte);
}

Turm::Turm(uint16_t Typ)
	: Sp(Trme[Typ].Sp), GImg(Trme[Typ].GImg), Schuss(Trme[Typ].Schuss), Reichweite(Trme[Typ].Reichweite), Durchschlag(Trme[Typ].Durchschlag),
	Schaden(Trme[Typ].Schaden), Verlangsamung(Trme[Typ].Verlangsamung), Preis(Trme[Typ].Preis), Kreis(nullptr), Ladezeit(Trme[Typ].Ladezeit), Schussgeschw(Trme[Typ].Schussgeschw)
{
	setPosition(Trme[Typ].getPosition());
}

Geschoss* Turm::Schiee(sf::Vector2i Ziel) {
	if(CircleCollision(static_cast<sf::Vector2f>(Ziel), Reichweite, getPosition(), 0.f) && Ladeuhr.getElapsedTime().asMilliseconds() > Ladezeit) {
		Ladeuhr.restart();
		float bWinkel = atan2(Ziel.y - getPosition().y, Ziel.x-getPosition().x);
		setRotation(90.f+radtodeg(bWinkel));
		sPlayer += Schuss;
		return(new Geschoss(GImg, getPosition(), bWinkel, Schussgeschw, Schaden, Durchschlag, Verlangsamung));
	}
	return(nullptr);
}

void Turm::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Sp, states);
	if (Kreis)
		Target.draw(*Kreis, states);
}
