#ifndef VALUEBOUNDLABEL_H
#define VALUEBOUNDLABEL_H

#include "Global.h"
#include "Control.h"
#include "EventHandler.h"
#include "Util.h"


template<typename T>
class ValueBoundLabel : public Control {
	mutable sf::Text Text;
	mutable T oldValue;
	const T& Value;
	std::string Prefix, Postfix;

	void draw(sf::RenderTarget& Target, sf::RenderStates states) const;
	void UpdateText() const;
public:
	EventHandler<void, void> OnTextUpdate;

	ValueBoundLabel(const T& v, const std::string& prefix = std::emptyString, const std::string& postfix = std::emptyString);

	sf::FloatRect getLocalBounds() const;
};


#include "ValueBoundLabel.inl"

#endif
