template<typename T>
ValueBoundLabel<T>::ValueBoundLabel(const T& v, const std::string& prefix, const std::string& postfix)
	: Value(v), Prefix(prefix), Postfix(postfix)
{
	Ondraw += std::bind(&ValueBoundLabel<T>::draw, this, std::placeholders::_1, std::placeholders::_2);
	UpdateText();
}

template<typename T>
void ValueBoundLabel<T>::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	if(Value != oldValue) UpdateText();

	Target.draw(Text, states);
}

template<typename T>
void ValueBoundLabel<T>::UpdateText() const {
	Text.setString(Prefix + std::to_string(Value) + Postfix);
	oldValue = Value;
	OnTextUpdate();
}

template<typename T>
sf::FloatRect ValueBoundLabel<T>::getLocalBounds() const {
	if(Value != oldValue) UpdateText();

	return(Text.getLocalBounds());
}
