#include "Window.h"
#include "Control.h"


Window::Window(sf::VideoMode mode, const sf::String& title, unsigned long style)
	: sf::RenderWindow(mode, title, style)
{
	setVerticalSyncEnabled(true);
}

void Window::HandleEvents() {
	sf::Event EV;
	while(pollEvent(EV)) {
		switch(EV.type) {
			case sf::Event::Closed:
				Onclose();
				close();
				break;
			case sf::Event::MouseMoved:
			{
				sf::Vector2i Point(EV.mouseMove.x, EV.mouseMove.y);
				for(auto i = Childs.crbegin(); i != Childs.crend(); ++i) {
					if((*i)->getLocalBounds().contains(static_cast<sf::Vector2f>(Point))) {
						(*i)->OnMouseMove(Point);
						break;
					}
				}
				break;
			}
			case sf::Event::MouseButtonPressed:
			{
				sf::Vector2i Point(EV.mouseButton.x, EV.mouseButton.y);
				for(auto i = Childs.crbegin(); i != Childs.crend(); ++i) {
					if((*i)->getLocalBounds().contains(static_cast<sf::Vector2f>(Point))) {
						(*i)->OnMouseButtonDown(Point, EV.mouseButton.button);
						break;
					}
				}
				break;
			}
			case sf::Event::MouseButtonReleased:
			{
				sf::Vector2i Point(EV.mouseButton.x, EV.mouseButton.y);
				for(auto i = Childs.crbegin(); i != Childs.crend(); ++i) {
					if((*i)->getLocalBounds().contains(static_cast<sf::Vector2f>(Point))) {
						(*i)->OnMouseButtonUp(Point, EV.mouseButton.button);
						break;
					}
				}
				break;
			}
			case sf::Event::KeyPressed:
				OnKeyDown(EV.key.code);
				break;
			case sf::Event::KeyReleased:
				OnKeyUp(EV.key.code);
				break;
		}
	}
}

void Window::display() {
	drawChilds(*this, sf::RenderStates());
	sf::RenderWindow::display();
	clear();
}
