#include "Button.h"
#include "Global.h"


void Button::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Rand, states);
	Target.draw(Text, states);
}

bool Button::IsClicked(const sf::Vector2i& MousePosition) {
	if(MousePosition.x > Rand.getPoint(0).x && MousePosition.x < Rand.getPoint(2).x && MousePosition.y > Rand.getPoint(0).y && MousePosition.y < Rand.getPoint(2).y) {
		if(!geklickt) {
			geklickt = true;
		}
	}
	else {
		geklickt = false;
	}
	return(geklickt);
}

void Button::setText(const std::string& sText) {
	Text.setString(sText);
}

void Button::setSize(const sf::Vector2f& Size) {
	Text.setPosition((Size.x - Text.getLocalBounds().width) / 2, (Size.y - Text.getCharacterSize() - Text.getLocalBounds().top) / 2);
	Rand = sf::RectangleShape(sf::Vector2f(Size.x - Border, Size.y - Border));
	Rand.setPosition(Border, Border);
	Rand.setOutlineThickness(Border);
	Rand.setOutlineColor(sf::Color(0,0,0,80));
	Rand.setFillColor(sf::Color::Transparent);
}

const sf::String& Button::getString() const {
	return(Text.getString());
}

Button::Button(const std::string& sText, const sf::Vector2f& Pos1, const sf::Vector2f& Pos2, int size, float border)
	: Border(border), geklickt(false), Text(sText, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	Text.setCharacterSize(size);
	Text.setColor(sf::Color(50,150,50));
	Text.setPosition((Pos2.x + Pos1.x - Text.getLocalBounds().width) / 2, (Pos2.y + Pos1.y - Text.getCharacterSize() - Text.getLocalBounds().top) / 2);
	Rand = sf::RectangleShape(sf::Vector2f(Pos2.x - Border, Pos2.y - Border));
	Rand.setPosition(Pos1.x + Border, Pos1.y + Border);
	Rand.setOutlineThickness(Border);
	Rand.setFillColor(sf::Color::Transparent);
	Rand.setOutlineColor(sf::Color(0,0,0,80));
}