#include "CheckBox.h"
#include "Global.h"


void CheckBox::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Rand, states);
	Target.draw(Text, states);
	if (Checked) {
		Target.draw(CheckMark1, states);
		Target.draw(CheckMark2, states);
	}
}

CheckBox::CheckBox(const sf::Vector2f& Position, const std::string& text)
	: Checked(false), Text(text, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	setPosition(Position);
	float Size = 15;
	CheckMark1.setFillColor(sf::Color::Black);
	CheckMark1.setPointCount(4);
	CheckMark1.setPoint(0, sf::Vector2f(0, Size / 2 - 2));
	CheckMark1.setPoint(1, sf::Vector2f(0, Size / 2 + 1));
	CheckMark1.setPoint(2, sf::Vector2f(Size / 2 - 1.5f, Size));
	CheckMark1.setPoint(3, sf::Vector2f(Size / 2 + 1.5f, Size - 1));
	CheckMark2.setFillColor(sf::Color::Black);
	CheckMark2.setPointCount(5);
	CheckMark2.setPoint(0, sf::Vector2f(Size / 2 - 1.5f, Size - 1));
	CheckMark2.setPoint(1, sf::Vector2f(Size / 2 + 1.5f, Size));
	CheckMark2.setPoint(2, sf::Vector2f(Size, 2));
	CheckMark2.setPoint(3, sf::Vector2f(Size, 0));
	CheckMark2.setPoint(4, sf::Vector2f(Size - 2, 0));
	Text.setPosition(Size + 3, - 3);
	Text.setCharacterSize(15);
	Text.setColor(sf::Color::Black);
	Rand = sf::RectangleShape(sf::Vector2f(Size, Size));
	Rand.setOutlineThickness(2);
	Rand.setOutlineColor(sf::Color(0,0,0,80));
	Rand.setFillColor(sf::Color::Transparent);
}

void CheckBox::IsClicked(const sf::Vector2i& MousePosition) {
	if(MousePosition.x > Rand.getPoint(0).x && MousePosition.x < Rand.getPoint(2).x && MousePosition.y > Rand.getPoint(0).y && MousePosition.y < Rand.getPoint(2).y) {
		Checked = !Checked;
	}
}
