#ifndef GLOBAL_H
#define GLOBAL_H

#include "Ressourcen.h"
#include "Button.h"
#include "TextBox.h"
#include "CheckBox.h"
#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>
#include <SFML/System.hpp>
#include <SFML/Network.hpp>
#include <cstdint>


enum MessageId {
	First = 0, Welcome,   // s:msg i:fieldsize i:maxships
	SystemMessage,        // s:msg
	Error,                // i:code s:msg
	Quit, AuthSuccessful, ChangeNickname, ReqMatchInfoList, MatchInfoList, CreateMatch, JoinMatch,
	JoinRandomMatch, LeaveMatch, MatchJoined, Matchleft, YourTurn, YourTurnEnded,
	PlaceShip, PlacementComplete, GameStarts, DropBomb, BombHit, BombMissed, YouWin,
	YouLose, Shutdown, Last
};
enum ErrorCode {
	Generic = 0, BadMessage, NotAllowed, WrongStatus, CannotPlaceShip, NotYourTurn,
	AlreadyBombed, InvalidPosition, UserlimitReached, BadNickname, MatchAlreadyStarted
};

extern const int KSize;
extern bool AmZug;
extern bool KISpielt;
extern TextBox Name;
extern sf::Clock Fehleruhr;
extern sf::Text Fehler;
extern sf::Sprite Hintergrund;
extern std::vector<Button> Spielauswahl;
extern CheckBox KI;
extern sf::Sound Hintergrundsound;
extern sf::Text AnDerReihe;
extern Button SetzenFertig;
extern Button Hauptmen;
extern Button ZuflligPlatzieren;
extern Button Men[4];
extern sf::Text Gegner;
extern sf::Text SpielZuEnde;

void SetFehler(const std::string& str);
void ResetFehler();

void SetRandomSchiffe();
void WerfeRandomBombe();
void ExitMatch();
void Reconnect();
void ResetSchiffFelder();

Resourcemanager& RM();


#endif
