#include "SoundLoop.h"
#include "Spielstatus.h"
#include <functional>


SoundLoop SoundPlayer;


SoundLoop::SoundLoop()
	: sf::Thread(std::bind(&SoundLoop::Run, this))
{
}

void SoundLoop::Run() {
	while(GetStatus() != ENDE) {
		if(!Warteschlange.empty() && !KISpielt) {
			Player.stop();
			switch(Warteschlange.front()) {
				case POSITION_EINGENOMMEN:
					Player.setBuffer(RM().get<sf::SoundBuffer>("Sound/PositionEingenommen.ogg"));
					break;
				case SCHIFF_Getroffen:
					Player.setBuffer(RM().get<sf::SoundBuffer>("Sound/SchiffGetroffen.ogg"));
					break;
				case FEIND_WEG:
					Player.setBuffer(RM().get<sf::SoundBuffer>("Sound/FeindWeg.ogg"));
					break;
			}
			Player.play();
			Warteschlange.pop();
			sf::sleep(Player.getBuffer()->getDuration());
		} else
			sf::sleep(sf::milliseconds(10));
	}
}

void SoundLoop::PlaySound(SOUND index) {
	Warteschlange.push(index);
}

void SoundLoop::clear() {
	Warteschlange = std::queue<SOUND>();
	Player.stop();
}
