#include "Spielfeld.h"


sf::Texture Spielfeld::Wasser;
sf::Texture Spielfeld::Bombardiert;
sf::Texture ImgGetroffen;

void Treffer(int x, int y, bool b) {
	FeldG.Getroffen(x,y,b);
}
void Getroffen(int x, int y, bool b) {
	FeldI.Getroffen(x,y,b);
}

void ResetSchiffFelder() {
	FeldI.Init(sf::Vector2f(187,221));
	FeldG.Init(sf::Vector2f(383,221));		
	for(uint8_t i = 0; i < 5; i++) {
		Schiffe[i].Init(i, sf::Vector2f(641.f, 193.f + i*static_cast<float>(KSize + 5)));
	}
}



Spielfeld FeldI, FeldG;

Spielfeld::Spielfeld() {
}

void Spielfeld::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	for(int i = 0; i < 10; i++) {
		for(int j = 0; j < 10; j++) {
			Target.draw(Kacheln[i][j], states);
		}
	}
}

void Spielfeld::Getroffen(int x, int y, bool b) {
	if(b) {
		Kacheln[x][y].setTexture(ImgGetroffen);
		Feldzustand[x][y] = 2;
		sf::Vector2<uint8_t> Koords;
		int Stck;
		for(int i = 0; i < 5; i++) {
			Koords = GetKoords(&Schiffe[i]);
			if(Schiffe[i].Vertikal) {
				if(x == Koords.x && y >= Koords.y && y < Koords.y + Schiffe[i].GetLnge()) {
					Stck = y-Koords.y;
					Schiffe[i].Getroffen(Stck);
				}
			}
			else {
				if(y == Koords.y && x >= Koords.x && x < Koords.x + Schiffe[i].GetLnge()) {
					Stck = x-Koords.x;
					Schiffe[i].Getroffen(Stck);
				}
			}
		}
	}
	else {
		Kacheln[x][y].setTexture(Bombardiert);
	}
}

void Spielfeld::Init(const sf::Vector2f& Pos) {
	Client.Treffer = ::Treffer;
	Client.Getroffen = ::Getroffen;
	setPosition(Pos);
	for(int i = 0; i < 10; i++) {
		for(int j = 0; j < 10; j++) {
			Kacheln[i][j].setTexture(Wasser);
			Kacheln[i][j].setPosition(Pos.x + i * KSize-1, Pos.y +  j * KSize-1);
			Feldzustand[i][j] = 0;
		}
	}
}

sf::Vector2<unsigned char> Spielfeld::GetKoords(Schiff *schiff) {
	sf::Vector2<sf::Uint8> Koord;
	Koord.x = static_cast<int>(schiff->getPosition().x - getPosition().x) / KSize;
	Koord.y = static_cast<int>(schiff->getPosition().y - getPosition().y) / KSize;
	return(Koord);
}

void Spielfeld::Click(const sf::Vector2i& MousePosition) {
	if(MousePosition.x > getPosition().x && MousePosition.y > getPosition().y && MousePosition.x < getPosition().x + KSize*10 && MousePosition.y < getPosition().y + KSize*10) {
		Client.Bombardieren(static_cast<int>(MousePosition.x - getPosition().x)/KSize, static_cast<int>(MousePosition.y - getPosition().y)/KSize);
		Feldzustand[static_cast<int>(MousePosition.x - getPosition().x)/KSize][static_cast<int>(MousePosition.y - getPosition().y)/KSize] = 1;
	}
}

void Spielfeld::SchiffAufFeld(Schiff *schiff, const sf::Vector2i& MousePosition) {
	if(MousePosition.x >= getPosition().x && MousePosition.y >= getPosition().y && 
		MousePosition.x <= getPosition().x + KSize * 10 && 
		MousePosition.y <= getPosition().y + KSize * 10 && schiff->Geklickt) {
			schiff->setPosition(std::max(getPosition().x, static_cast<int>((MousePosition.x - getPosition().x) / KSize) * KSize + getPosition().x), std::max(getPosition().y, static_cast<int>((MousePosition.y - getPosition().y) / KSize) * KSize + getPosition().y));
			if(schiff->Vertikal) {
				if(schiff->getPosition().y + schiff->GetLnge() * KSize >= getPosition().y + 10 * KSize) {
					schiff->setPosition(schiff->getPosition().x, getPosition().y + (10-schiff->GetLnge()) * KSize);
				}
			}
			else {
				if(schiff->getPosition().x + schiff->GetLnge() * KSize >= getPosition().x + 10 * KSize) {
					schiff->setPosition(getPosition().x + (10-schiff->GetLnge()) * KSize, schiff->getPosition().y);;
				}
			}
	}
}

bool Spielfeld::Prfen() {
	bool Besetzt[10][10];
	for(int i = 0; i < 10; i++) {
		for(int j = 0; j < 10; j++) {
			Besetzt[i][j] = false;
		}
	}
	for(int i = 0; i < 5; i++) {
		if(Schiffe[i].Vertikal) {
			if(Schiffe[i].getPosition().x >= getPosition().x && 
				Schiffe[i].getPosition().y >= getPosition().y && 
				Schiffe[i].getPosition().x + KSize <= getPosition().x + KSize * 10 && 
				Schiffe[i].getPosition().y + KSize * Schiffe[i].GetLnge() <= getPosition().y + KSize*10) {
				for(int j = 0; j < Schiffe[i].GetLnge(); j++) {
					if(!Besetzt[(int)(Schiffe[i].getPosition().x - getPosition().x) / KSize][(int)(Schiffe[i].getPosition().y - getPosition().y) / KSize + j]) {
						Besetzt[(int)(Schiffe[i].getPosition().x - getPosition().x) / KSize][(int)(Schiffe[i].getPosition().y - getPosition().y) / KSize + j] = true;
					}
					else {
						return(false);
					}
				}
			}
			else {
				return(false);
			}
		}
		else {
			if(Schiffe[i].getPosition().x >= getPosition().x && 
				Schiffe[i].getPosition().y >= getPosition().y && 
				Schiffe[i].getPosition().x + KSize * Schiffe[i].GetLnge() <= getPosition().x + KSize*10 && 
				Schiffe[i].getPosition().y + KSize <= getPosition().y + KSize * 10) {
				for(int j = 0; j < Schiffe[i].GetLnge(); j++) {
					if(!Besetzt[(int)(Schiffe[i].getPosition().x - getPosition().x) / KSize + j][(int)(Schiffe[i].getPosition().y - getPosition().y) / KSize]) {
						Besetzt[(int)(Schiffe[i].getPosition().x - getPosition().x) / KSize + j][(int)(Schiffe[i].getPosition().y - getPosition().y) / KSize] = true;
					}
					else {
						return(false);
					}
				}
			}
			else {
				return(false);
			}
		}
	}
	return(true);
}
