#include "Spielstatus.h"
#include "SoundLoop.h"


STATUS Spielstatus;

STATUS GetStatus() {
	return(Spielstatus);
}

void InitStati() {
	SetStatus(NAME);
}

void SetStatus(STATUS state) {
	if(state > MEN && Spielstatus == MEN) {
		KISpielt = KI.Checked;
	}
	else if(state == MEN && Spielstatus >= WARTEN) {
		SoundPlayer.clear();
		Hintergrundsound.stop();
		ExitMatch();
	}
	if(state == NAME && Spielstatus >= MEN) {
		Reconnect();
	}
	if(state != WARTEN && Spielstatus == AUSWAHL) {
		Spielauswahl.clear();
	}
	switch(state) {
		case NAME:
			Hintergrund.setTexture(RM().get<sf::Texture>("Grafik/Hintergrund0.png"));
			break;
		case MEN:
			Hintergrund.setTexture(RM().get<sf::Texture>("Grafik/Hintergrund1.png"));
			break;
		case AUSWAHL:
			Hauptmen.setPosition(sf::Vector2f(555, 260));
			Hauptmen.setSize(sf::Vector2f(240, 80));
			break;
		case WARTEN:
			Hintergrund.setTexture(RM().get<sf::Texture>("Grafik/Hintergrund2.png"));
			Hauptmen.setPosition(sf::Vector2f(250, 150));
			Hauptmen.setSize(sf::Vector2f(300, 100));
			break;
		case SetzeN:
			AnDerReihe.setString("Bitte bringen Sie ihre Flotte auf Position!");
			AnDerReihe.setPosition(400-AnDerReihe.getLocalBounds().width/2,430);
			Hintergrundsound.play();
			Hintergrund.setTexture(RM().get<sf::Texture>("Grafik/Hintergrund3.png"));
			Hauptmen.setPosition(sf::Vector2f(220, 535));
			Hauptmen.setSize(sf::Vector2f(310, 60));
			ResetSchiffFelder();
			break;
		case GESETZT:
			AnDerReihe.setString("Bitte warten Sie, bis der Gegner\nseine Flotte positioniert hat!");
			AnDerReihe.setPosition(400-AnDerReihe.getLocalBounds().width/2,435);
			break;
		case WERFEN:
			AnDerReihe.setString("Bitte warten Sie auf den gegnerischen Angriff!");
			AnDerReihe.setPosition(400-AnDerReihe.getLocalBounds().width/2,435);
			break;
		case GEWONNEN:
			SpielZuEnde.setString("Gewonnen!");
			SpielZuEnde.setCharacterSize(100);
			SpielZuEnde.setColor(sf::Color(175, 50, 50));
			SpielZuEnde.setPosition(400-SpielZuEnde.getLocalBounds().width/2, 300 - SpielZuEnde.getLocalBounds().height/2);
			break;
		case VERLOREN:
			SpielZuEnde.setString("Gewonnen!");
			SpielZuEnde.setCharacterSize(100);
			SpielZuEnde.setColor(sf::Color(175, 50, 50));
			SpielZuEnde.setPosition(400-SpielZuEnde.getLocalBounds().width/2, 300 - SpielZuEnde.getLocalBounds().height/2);
			break;
		case ENDE: default:
			break;
	}
	Spielstatus = state;
}
