#include "TextBox.h"
#include "Global.h"

static const std::string allowedchar = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_()[]";


TextBox::TextBox(const std::string& sText, const std::string& lText, const sf::Vector2f& Position)
	: Leertext(lText), Inhalt(sText), Text(lText, RM().get<sf::Font>("../Fonts/sansation.ttf"))
{
	setPosition(Position);
	Text.setCharacterSize(30);
	Text.setColor(sf::Color::Black);
	if (!Inhalt.empty()) {
		Text.setColor(sf::Color::Black);
		Text.setString(Inhalt);
	}
	else {
		Text.setColor(sf::Color(0,0,0,100));
	}
	static const sf::Glyph& g = Text.getFont()->getGlyph('g', Text.getCharacterSize(), Text.getStyle() & sf::Text::Bold);
	static const sf::Glyph& n = Text.getFont()->getGlyph('n', Text.getCharacterSize(), Text.getStyle() & sf::Text::Bold);
	static const sf::Glyph& k = Text.getFont()->getGlyph('k', Text.getCharacterSize(), Text.getStyle() & sf::Text::Bold);
	Text.setPosition(-sf::Vector2f(Text.getLocalBounds().width / 2, (g.bounds.height + k.bounds.height - n.bounds.height + 10) / 2));
	Rand = sf::RectangleShape(sf::Vector2f(Text.getLocalBounds().width + 10, g.bounds.height + k.bounds.height - n.bounds.height + 10));
	Rand.setFillColor(sf::Color::White);
	Rand.setOutlineColor(sf::Color(0,0,80));
	Rand.setOutlineThickness(5);
	Rand.setPosition(Text.getPosition().x-5, Text.getPosition().y);
}

bool TextBox::IsNotLeer() {
	return !Inhalt.empty();
}

void TextBox::AddText(char c) {
	if(c == 8) {
		if(Inhalt.length() > 0) {
			Inhalt.erase(Inhalt.length()-1, 1);
		}
	}
	else if (allowedchar.find(c) != -1) {
		if(Inhalt.length() < 16) {
			Inhalt += c;
		}
	}
	if (!Inhalt.empty()) {
		Text.setColor(sf::Color::Black);
		Text.setString(Inhalt);
	}
	else {
		Text.setColor(sf::Color(0,0,0,100));
		Text.setString(Leertext);
	}
	static const sf::Glyph& g = Text.getFont()->getGlyph('g', Text.getCharacterSize(), Text.getStyle() & sf::Text::Bold);
	static const sf::Glyph& n = Text.getFont()->getGlyph('n', Text.getCharacterSize(), Text.getStyle() & sf::Text::Bold);
	static const sf::Glyph& k = Text.getFont()->getGlyph('k', Text.getCharacterSize(), Text.getStyle() & sf::Text::Bold);
	Text.setPosition(-sf::Vector2f(Text.getLocalBounds().width / 2, (g.bounds.height + k.bounds.height - n.bounds.height + 10) / 2));
	Rand = sf::RectangleShape(sf::Vector2f(Text.getLocalBounds().width + 10, g.bounds.height + k.bounds.height - n.bounds.height + 10));
	Rand.setPosition(Text.getPosition().x - 5, Text.getPosition().y);
	Rand.setFillColor(sf::Color::White);
	Rand.setOutlineThickness(5);
	Rand.setOutlineColor(sf::Color(0,0,80));
}

const std::string& TextBox::getString() const {
	return Inhalt;
}

void TextBox::draw(sf::RenderTarget& Target, sf::RenderStates states) const {
	states.transform *= getTransform();
	Target.draw(Rand, states);
	Target.draw(Text, states);
}
